import gl4java.GLContext;
import gl4java.awt.GLCanvas;
import gl4java.utils.glut.*;
import gl4java.*;
import gl4java.utils.textures.*;

/**
* COLORS
* GL-class where all the colors
* I use is. And some components.
* @author Marte Horne
* @version  1 - 2002...
*/
public class ColorsAndComponents extends GLCanvas
{		
	private GLUTFunc glut = null;
	private Playing playing = new Playing();
	private Josefine josefine = new Josefine();
	private Referee referee = new Referee();
	
	int []texName = new int[1];
   
   /**
   * Konstruktr
   * @param height
   * @param widht
	*/
	public ColorsAndComponents(int w, int h)
   {
     super(w, h);
   }

	/**
	* init()
	*/
   public void init()
   {
      glut = new GLUTFuncLightImpl(gl, glu);
   }
   
   /**
	* makeSkirt
	* @param qd glu.gluNewQuadric()
	*/
   public void makeSkirt(long qd)
   {       	
   	//numbers of points horizontal
   	//and vertical
   	int UN =5;   
   	int VN =4;   
  
   	//size
   	float SKIRT = 0.4f;
  
		float ctr0=0.1f*SKIRT;	  
   	float ctr1=0.5f*SKIRT;
   	float ctr2=0.7f*SKIRT;
   	float ctr3=0.7f*SKIRT;
   	/** offset along z */
   	float ctz1=0.0f*SKIRT;
   	float ctz2=0.3f*SKIRT;
   	float ctz3=1.0f*SKIRT;
   	float ctz4=SKIRT;
  
   	/** factor for circlecompensation */
   	float rf=1.35f;
   	
   	/** Bezier points */
   	float M[] =
   	{     
         ctr0,0.0f,ctz1,
         ctr0,ctr0,ctz1,
         0.0f,rf*ctr0,ctz1,
         -ctr0,ctr0,ctz1,
         -ctr0,0.0f,ctz1,
         
         ctr1,0.0f,ctz1,
         ctr1,ctr1,ctz1,
         0.0f,rf*ctr1,ctz1,
         -ctr1,ctr1,ctz1,
         -ctr1,0.0f,ctz1,

         ctr2,0.0f,ctz2,
         ctr2,ctr2,ctz2,
         0.0f,rf*ctr2,ctz2,
         -ctr2,ctr2,ctz2,
         -ctr2,0.0f,ctz2,

         ctr3,0.0f,ctz3,
         ctr3,ctr3,ctz3,
         0.0f,rf*ctr3,ctz3,
         -ctr3,ctr3,ctz3,
         -ctr3,0.0f,ctz3
   	};
   	
   	//maps the skirt
	   gl.glMap2f(GL_MAP2_VERTEX_3,0.0f,1.0f,3,UN,0.0f,1.0f,3*UN,VN,M);
   	gl.glEnable(GL_MAP2_VERTEX_3);
	   gl.glEnable(GL_AUTO_NORMAL);
	   gl.glEnable(GL_NORMALIZE);
	
	   gl.glMapGrid2f(20,0.0f,1.0f,20,0.0f, 1.0f);
	   gl.glFrontFace(GL_CW);		   
	   gl.glEvalMesh2(GL_FILL, 0, 20, 0, 20);
	   gl.glFrontFace(GL_CCW);
	   
	   //Rotates the skirt 180 degrees and
	   //draw it one more time
	   gl.glRotatef(180.0f,0.0f,0.0f,1.0f);
 		gl.glEvalMesh2(GL_FILL, 0, 20, 0, 20);
 		gl.glFrontFace(GL_CCW); 
	}
	
   /**
	* makeChair
	* @param qd glu.gluNewQuadric()
	*/
   public void makeChair(long qd)
	{
		//size
		float CHAIR = 0.4f;
		
		gl.glPushMatrix();
			gl.glTranslated(0.0f,1.3f,-3.0f);
	
			//******************************
			//The seat of the chair
			//******************************
			//Lowest
		   gl.glBegin(GL_POLYGON);
	         setNormalMaterial_brown();
	         gl.glVertex3f(-0.9f*CHAIR, 0.0f*CHAIR, 0.2f*CHAIR);
	         gl.glVertex3f(0.9f*CHAIR, 0.0f*CHAIR, 0.2f*CHAIR);
	         gl.glVertex3f(0.9f*CHAIR, 0.0f*CHAIR, -1.6f*CHAIR);
	         gl.glVertex3f(-0.9f*CHAIR, 0.0f*CHAIR,-1.6f*CHAIR);
	      gl.glEnd();
            
	      //In front
	      gl.glBegin(GL_POLYGON);
	         setNormalMaterial_brown_2();
	         gl.glVertex3f(-0.9f*CHAIR, 0.0f*CHAIR, 0.2f*CHAIR);
	         gl.glVertex3f(0.9f*CHAIR, 0.0f*CHAIR, 0.2f*CHAIR);
	         gl.glVertex3f(0.9f*CHAIR, 0.2f*CHAIR, 0.2f*CHAIR);
	         gl.glVertex3f(-0.9f*CHAIR, 0.2f*CHAIR,0.2f*CHAIR);
	      gl.glEnd();
	            
	      //Right
	      gl.glBegin(GL_POLYGON);
	         setNormalMaterial_brown_2();
	         gl.glVertex3f(0.9f*CHAIR, 0.0f*CHAIR, 0.2f*CHAIR);
	         gl.glVertex3f(0.9f*CHAIR, 0.0f*CHAIR, -1.6f*CHAIR);
	         gl.glVertex3f(0.9f*CHAIR, 0.2f*CHAIR, -1.6f*CHAIR);
	         gl.glVertex3f(0.9f*CHAIR, 0.2f*CHAIR, 0.2f*CHAIR);
	      gl.glEnd();
	      
	      //the back
	      gl.glBegin(GL_POLYGON);
	         setNormalMaterial_brown_2();
	         gl.glVertex3f(-0.9f*CHAIR, 0.0f*CHAIR, -1.6f*CHAIR);
	         gl.glVertex3f(0.9f*CHAIR, 0.0f*CHAIR, -1.6f*CHAIR);
	         gl.glVertex3f(0.9f*CHAIR, 0.2f*CHAIR, -1.6f*CHAIR);
	         gl.glVertex3f(-0.9f*CHAIR, 0.2f*CHAIR, -1.6f*CHAIR);
	      gl.glEnd();
	            
	      //Left
	      gl.glBegin(GL_POLYGON);
	         setNormalMaterial_brown_2();
	         gl.glVertex3f(-0.9f*CHAIR, 0.0f*CHAIR, 0.2f*CHAIR);
	         gl.glVertex3f(-0.9f*CHAIR, 0.0f*CHAIR, -1.6f*CHAIR);
	         gl.glVertex3f(-0.9f*CHAIR, 0.2f*CHAIR, -1.6f*CHAIR);
	         gl.glVertex3f(-0.9f*CHAIR, 0.2f*CHAIR, 0.2f*CHAIR);
	      gl.glEnd();
	      
	      //the top
		   gl.glBegin(GL_POLYGON);
	         setNormalMaterial_brown();
	         gl.glVertex3f(-0.9f*CHAIR, 0.2f*CHAIR, 0.2f*CHAIR);
	         gl.glVertex3f(0.9f*CHAIR, 0.2f*CHAIR, 0.2f*CHAIR);
	         gl.glVertex3f(0.9f*CHAIR, 0.2f*CHAIR, -1.6f*CHAIR);
	         gl.glVertex3f(-0.9f*CHAIR, 0.2f*CHAIR,-1.6f*CHAIR);
	      gl.glEnd();
	
			//******************************
			//Legs of chair
			//******************************
		   gl.glPushMatrix();
		   	setNormalMaterial_brown();
		   	gl.glTranslated(-0.7f*CHAIR,0.0f,0.0f);
		   	gl.glRotatef(90.0f,1.0f,0.0f,0.0f);
			   glu.gluCylinder(qd,0.1*CHAIR,0.1*CHAIR,3.2*CHAIR,20,20);
		   gl.glPopMatrix();
	      	  
		  	gl.glPushMatrix();
			   setNormalMaterial_brown();
		   	gl.glTranslated(0.7f*CHAIR,0.0f,0.0f);
		   	gl.glRotatef(90.0f,1.0f,0.0f,0.0f);
			   glu.gluCylinder(qd,0.1*CHAIR,0.1*CHAIR,3.2*CHAIR,20,20);
		   gl.glPopMatrix();
			
		 	   
		   gl.glPushMatrix();
			   setNormalMaterial_brown();
		   	gl.glTranslated(0.7f*CHAIR,0.0f,-1.4f*CHAIR);
		   	gl.glRotatef(90.0f,1.0f,0.0f,0.0f);
			   glu.gluCylinder(qd,0.1*CHAIR,0.1*CHAIR,3.2*CHAIR,20,20);
		   gl.glPopMatrix();
		   
	      gl.glPushMatrix();
			   setNormalMaterial_brown();
		   	gl.glTranslated(-0.7f*CHAIR,0.0f,-1.4f*CHAIR);
		   	gl.glRotatef(90.0f,1.0f,0.0f,0.0f);
			   glu.gluCylinder(qd,0.1*CHAIR,0.1*CHAIR,3.2*CHAIR,20,20);
		   gl.glPopMatrix();
		   
		   //The cross at the left side
		   gl.glPushMatrix();
			   setNormalMaterial_brown();
		   	gl.glTranslated(0.7f*CHAIR,-0.2f,-1.4f*CHAIR);
		   	gl.glRotatef(55.0f,1.0f,0.0f,0.0f);
			   glu.gluCylinder(qd,0.1*CHAIR,0.1*CHAIR,2.5*CHAIR,20,20);
		   gl.glPopMatrix();
		   
		   gl.glPushMatrix();
			   setNormalMaterial_brown();
		   	gl.glTranslated(-0.7f*CHAIR,-0.2f,0.0f*CHAIR);
		   	gl.glRotatef(125.0f,1.0f,0.0f,0.0f);
			   glu.gluCylinder(qd,0.1*CHAIR,0.1*CHAIR,2.5*CHAIR,20,20);
		   gl.glPopMatrix();
		   
		   //The cross at the right side
		   gl.glPushMatrix();
			   setNormalMaterial_brown();
		   	gl.glTranslated(0.7f*CHAIR,-0.2f,0.0f*CHAIR);
		   	gl.glRotatef(125.0f,1.0f,0.0f,0.0f);
			   glu.gluCylinder(qd,0.1*CHAIR,0.1*CHAIR,2.5*CHAIR,20,20);
		   gl.glPopMatrix();
		   
		   gl.glPushMatrix();
			   setNormalMaterial_brown();
		   	gl.glTranslated(-0.7f*CHAIR,-0.2f,-1.4f*CHAIR);
		   	gl.glRotatef(55.0f,1.0f,0.0f,0.0f);
			   glu.gluCylinder(qd,0.1*CHAIR,0.1*CHAIR,2.5*CHAIR,20,20);
		   gl.glPopMatrix();
		   
		   //The stairs down from the chair
		   gl.glPushMatrix();
			   setNormalMaterial_brown();
		   	gl.glTranslated(-0.7f*CHAIR,-0.25f,0.0f*CHAIR);
		   	gl.glRotatef(90.0f,0.0f,1.0f,0.0f);
			   glu.gluCylinder(qd,0.1*CHAIR,0.1*CHAIR,1.3*CHAIR,20,20);
			   
			   gl.glTranslated(0.0f*CHAIR,-0.25f,0.0f*CHAIR);
			   glu.gluCylinder(qd,0.1*CHAIR,0.1*CHAIR,1.3*CHAIR,20,20);
			   
			   gl.glTranslated(0.0f*CHAIR,-0.25f,0.0f*CHAIR);
			   glu.gluCylinder(qd,0.1*CHAIR,0.1*CHAIR,1.3*CHAIR,20,20);
			   
			   gl.glTranslated(0.0f*CHAIR,-0.25f,0.0f*CHAIR);
			   glu.gluCylinder(qd,0.1*CHAIR,0.1*CHAIR,1.3*CHAIR,20,20);
		   gl.glPopMatrix();
		 
		   //back of the chair
		   gl.glPushMatrix();
			   setNormalMaterial_brown();
		   	gl.glTranslated(-0.7f*CHAIR,0.0f,-1.4f*CHAIR);
		   	gl.glRotatef(-90.0f,1.0f,0.0f,0.0f);
			   glu.gluCylinder(qd,0.07*CHAIR,0.07*CHAIR,1.9*CHAIR,20,20);
		   gl.glPopMatrix();
	      	 
		   gl.glPushMatrix();
			   setNormalMaterial_brown();
		   	gl.glTranslated(0.7f*CHAIR,0.0f,-1.4f*CHAIR);
		   	gl.glRotatef(-90.0f,1.0f,0.0f,0.0f);
			   glu.gluCylinder(qd,0.07*CHAIR,0.07*CHAIR,1.9*CHAIR,20,20);
		   gl.glPopMatrix();
		   
		   gl.glPushMatrix();
			   setNormalMaterial_brown();
		   	gl.glTranslated(0.7f*CHAIR,0.1f,-1.4f*CHAIR);
		   	gl.glRotatef(-90.0f,1.0f,0.0f,0.0f);
		   	gl.glRotatef(-43.0f,0.0f,1.0f,0.0f);
			   glu.gluCylinder(qd,0.07*CHAIR,0.07*CHAIR,2.1*CHAIR,20,20);
		   gl.glPopMatrix();
		   
		   gl.glPushMatrix();
			   setNormalMaterial_brown();
		   	gl.glTranslated(-0.7f*CHAIR,0.1f,-1.4f*CHAIR);
		   	gl.glRotatef(-90.0f,1.0f,0.0f,0.0f);
		   	gl.glRotatef(43.0f,0.0f,1.0f,0.0f);
			   glu.gluCylinder(qd,0.07*CHAIR,0.07*CHAIR,2.1*CHAIR,20,20);
		   gl.glPopMatrix();
	      	 
	      gl.glPushMatrix();
			   setNormalMaterial_brown();
		   	gl.glTranslated(-1.0f*CHAIR,1.7f*CHAIR,-1.4f*CHAIR);
		   	gl.glRotatef(90.0f,0.0f,1.0f,0.0f);
			   glu.gluCylinder(qd,0.07*CHAIR,0.07*CHAIR,2.0*CHAIR,20,20);
	      gl.glPopMatrix();
      
      gl.glPopMatrix();
   }

   /**
	* Makes the court
	* @param qd glu.gluNewQuadric()
	*/
   public void makeCourt(long qd)
   {  
   	//the green ground around
   	gl.glBegin(GL_POLYGON);
         setNormalMaterial_green();
         gl.glVertex3f(-6.0f, -0.01f,  4.0f);
         gl.glVertex3f( 6.0f, -0.01f,  4.0f);
         gl.glVertex3f( 6.0f, -0.01f, -4.0f);
         gl.glVertex3f(-6.0f, -0.01f, -4.0f);
      gl.glEnd();
   	
      //the red bottom
      gl.glBegin(GL_POLYGON);
         setNormalMaterial_tennisbane();
         gl.glVertex3f(-5.0f, 0.0f,  2.5f);
         gl.glVertex3f( 5.0f, 0.0f,  2.5f);
         gl.glVertex3f( 5.0f, 0.0f, -2.5f);
         gl.glVertex3f(-5.0f, 0.0f, -2.5f);
      gl.glEnd();
      
      //the white lines
      gl.glBegin(GL_POLYGON);
         setNormalMaterial_white();
         gl.glVertex3f(-5.0f, 0.01f,  2.5f);
         gl.glVertex3f(-4.95f, 0.01f,  2.5f);
         gl.glVertex3f(-4.95f, 0.01f, -2.5f);
         gl.glVertex3f(-5.0f, 0.01f, -2.5f);
      gl.glEnd();
      
      gl.glBegin(GL_POLYGON);
         setNormalMaterial_white();
         gl.glVertex3f(5.0f, 0.01f,  2.5f);
         gl.glVertex3f(4.95f, 0.01f,  2.5f);
         gl.glVertex3f(4.95f, 0.01f, -2.5f);
         gl.glVertex3f(5.0f, 0.01f, -2.5f);
      gl.glEnd();
      
      
      gl.glBegin(GL_POLYGON);
         setNormalMaterial_white();
         gl.glVertex3f(-5.0f, 0.01f,  2.5f);
         gl.glVertex3f(5.0f, 0.01f,  2.5f);
         gl.glVertex3f(5.0f, 0.01f, 2.45f);
         gl.glVertex3f(-5.0f, 0.01f, 2.45f);
      gl.glEnd();
      
      
      gl.glBegin(GL_POLYGON);
         setNormalMaterial_white();
         gl.glVertex3f(-5.0f, 0.01f,  -2.5f);
         gl.glVertex3f(5.0f, 0.01f,  -2.5f);
         gl.glVertex3f(5.0f, 0.01f, -2.45f);
         gl.glVertex3f(-5.0f, 0.01f, -2.45f);
      gl.glEnd();
      
      gl.glBegin(GL_POLYGON);
         setNormalMaterial_white();
         gl.glVertex3f(-5.0f, 0.01f,  -2.1f);
         gl.glVertex3f(5.0f, 0.01f,  -2.1f);
         gl.glVertex3f(5.0f, 0.01f, -2.05f);
         gl.glVertex3f(-5.0f, 0.01f, -2.05f);
      gl.glEnd();
      
      gl.glBegin(GL_POLYGON);
         setNormalMaterial_white();
         gl.glVertex3f(-5.0f, 0.01f,  2.1f);
         gl.glVertex3f(5.0f, 0.01f,  2.1f);
         gl.glVertex3f(5.0f, 0.01f, 2.05f);
         gl.glVertex3f(-5.0f, 0.01f, 2.05f);
      gl.glEnd();
      
      gl.glBegin(GL_POLYGON);
         setNormalMaterial_white();
         gl.glVertex3f(-3.0f, 0.01f,  2.05f);
         gl.glVertex3f(-2.95f, 0.01f,  2.05f);
         gl.glVertex3f(-2.95f, 0.01f, -2.05f);
         gl.glVertex3f(-3.0f, 0.01f, -2.05f);
      gl.glEnd();
      
      gl.glBegin(GL_POLYGON);
         setNormalMaterial_white();
         gl.glVertex3f(3.0f, 0.01f,  2.05f);
         gl.glVertex3f(2.95f, 0.01f,  2.05f);
         gl.glVertex3f(2.95f, 0.01f, -2.05f);
         gl.glVertex3f(3.0f, 0.01f, -2.05f);
      gl.glEnd();
      
      gl.glBegin(GL_POLYGON);
         setNormalMaterial_white();
         gl.glVertex3f(-3.0f, 0.01f,  0.05f);
         gl.glVertex3f(3.0f, 0.01f,  0.05f);
         gl.glVertex3f(3.0f, 0.01f, -0.0f);
         gl.glVertex3f(-3.0f, 0.01f, -0.0f);
      gl.glEnd();
      
      gl.glBegin(GL_POLYGON);
         setNormalMaterial_white();
         gl.glVertex3f(0.05f, 0.01f,  2.5f);
         gl.glVertex3f(-0.0f, 0.01f,  2.5f);
         gl.glVertex3f(-0.0f, 0.01f, -2.5f);
         gl.glVertex3f(0.05f, 0.01f, -2.5f);
      gl.glEnd();  
   }
   
   /**
	* Draws the lane to the ball if you
	* choose it in the menu
	* @param qd glu.gluNewQuadric()
	*/
   public void drawLane(long qd, String bane)
   {    
      gl.glPushMatrix();

			if (bane == "en")
			{
				//Josefine servers the ball til Josef
			   gl.glMap2f(GL_MAP2_VERTEX_3,0.0f,1.0f,3,playing.getUN_1(),0.0f,1.0f,3*playing.getUN_1(),playing.getVN_1(),playing.getctrlpoints_1());
			   gl.glEnable(GL_MAP2_VERTEX_3);
			   gl.glEnable(GL_AUTO_NORMAL);
			   gl.glEnable(GL_NORMALIZE);		
			   gl.glMapGrid2f(20,0.0f,1.0f,20,0.0f, 1.0f);
			   gl.glFrontFace(GL_CW);		   
			   gl.glEvalMesh2(GL_LINE, 0, 20, 0, 20);
			   gl.glFrontFace(GL_CCW);
			   
			   gl.glMap2f(GL_MAP2_VERTEX_3,0.0f,1.0f,3,playing.getUN_2(),0.0f,1.0f,3*playing.getUN_2(),playing.getVN_2(),playing.getctrlpoints_2());
			   gl.glEnable(GL_MAP2_VERTEX_3);
			   gl.glEnable(GL_AUTO_NORMAL);
			   gl.glEnable(GL_NORMALIZE);		
			   gl.glMapGrid2f(20,0.0f,1.0f,20,0.0f, 1.0f);
			   gl.glFrontFace(GL_CW);		   
			   gl.glEvalMesh2(GL_LINE, 0, 20, 0, 20);
			   gl.glFrontFace(GL_CCW);
		   }
		   
		   else if (bane == "to")
		   {
			   //Josef hits the ball back
			   gl.glMap2f(GL_MAP2_VERTEX_3,0.0f,1.0f,3,playing.getUN_3(),0.0f,1.0f,3*playing.getUN_3(),playing.getVN_3(),playing.getctrlpoints_3());
			   gl.glEnable(GL_MAP2_VERTEX_3);
			   gl.glEnable(GL_AUTO_NORMAL);
			   gl.glEnable(GL_NORMALIZE);		
			   gl.glMapGrid2f(20,0.0f,1.0f,20,0.0f, 1.0f);
			   gl.glFrontFace(GL_CW);		   
			   gl.glEvalMesh2(GL_LINE, 0, 20, 0, 20);
			   gl.glFrontFace(GL_CCW);
			   
			   gl.glMap2f(GL_MAP2_VERTEX_3,0.0f,1.0f,3,playing.getUN_4(),0.0f,1.0f,3*playing.getUN_4(),playing.getVN_4(),playing.getctrlpoints_4());
			   gl.glEnable(GL_MAP2_VERTEX_3);
			   gl.glEnable(GL_AUTO_NORMAL);
			   gl.glEnable(GL_NORMALIZE);		
			   gl.glMapGrid2f(20,0.0f,1.0f,20,0.0f, 1.0f);
			   gl.glFrontFace(GL_CW);		   
			   gl.glEvalMesh2(GL_LINE, 0, 20, 0, 20);
			   gl.glFrontFace(GL_CCW);
		   }
		   
		   else if (bane == "tre")
		   {
			   //JOsefine hits the ball again
			   gl.glMap2f(GL_MAP2_VERTEX_3,0.0f,1.0f,3,playing.getUN_5(),0.0f,1.0f,3*playing.getUN_5(),playing.getVN_5(),playing.getctrlpoints_5());
			   gl.glEnable(GL_MAP2_VERTEX_3);
			   gl.glEnable(GL_AUTO_NORMAL);
			   gl.glEnable(GL_NORMALIZE);		
			   gl.glMapGrid2f(20,0.0f,1.0f,20,0.0f, 1.0f);
			   gl.glFrontFace(GL_CW);		   
			   gl.glEvalMesh2(GL_LINE, 0, 20, 0, 20);
			   gl.glFrontFace(GL_CCW);
			   
			   gl.glMap2f(GL_MAP2_VERTEX_3,0.0f,1.0f,3,playing.getUN_2(),0.0f,1.0f,3*playing.getUN_2(),playing.getVN_2(),playing.getctrlpoints_2());
			   gl.glEnable(GL_MAP2_VERTEX_3);
			   gl.glEnable(GL_AUTO_NORMAL);
			   gl.glEnable(GL_NORMALIZE);		
			   gl.glMapGrid2f(20,0.0f,1.0f,20,0.0f, 1.0f);
			   gl.glFrontFace(GL_CW);		   
			   gl.glEvalMesh2(GL_LINE, 0, 20, 0, 20);
			   gl.glFrontFace(GL_CCW);
		   }
		   
		   else if (bane == "fire")
		   {
		   	//Josef lose
			   gl.glMap2f(GL_MAP2_VERTEX_3,0.0f,1.0f,3,playing.getUN_6(),0.0f,1.0f,3*playing.getUN_6(),playing.getVN_6(),playing.getctrlpoints_6());
			   gl.glEnable(GL_MAP2_VERTEX_3);
			   gl.glEnable(GL_AUTO_NORMAL);
			   gl.glEnable(GL_NORMALIZE);		
			   gl.glMapGrid2f(20,0.0f,1.0f,20,0.0f, 1.0f);
			   gl.glFrontFace(GL_CW);		   
			   gl.glEvalMesh2(GL_LINE, 0, 20, 0, 20);
			   gl.glFrontFace(GL_CCW);
			}		   
		gl.glPopMatrix();	    
	}
	
	
	
	/**
	* Makes the hat
	* @param qd glu.gluNewQuadric()
	*/
   public void makeHat(long qd)  
   {
      float HAT = 0.3f;
      
      //The bottom
      gl.glPushMatrix();
		gl.glTranslated(0.0f,2.1f*HAT,0.0f);
		gl.glRotatef(-90.0f,1.0f,0.0f,0.0f);
      setNormalMaterial_black();
      glu.gluDisk(qd,0.0f,0.8f*HAT,20,20);
      //The sylinder between
      glu.gluCylinder(qd,0.5*HAT,0.5*HAT,0.9*HAT,20,20);
      //The top
		gl.glTranslated(0.0f,0.0f,0.9f*HAT);
      glu.gluDisk(qd,0.0f,0.5f*HAT,20,20);
      gl.glPopMatrix();
   }
	
	/**
	* white color
	*/
   public void setNormalMaterial_white()
   {   
      float amb[]={1.0f,1.0f,1.0f,1.0f};
  		float diff[]={1.0f,1.0f,1.0f,1.0f};
  		float spec[]={1.0f,1.0f,1.0f,1.0f};
  		float shine=85f;
      gl.glMaterialfv(GL_FRONT,GL_AMBIENT,amb);
      gl.glMaterialfv(GL_FRONT,GL_DIFFUSE,diff);
      gl.glMaterialfv(GL_FRONT,GL_SPECULAR,spec);
      gl.glMaterialf(GL_FRONT,GL_SHININESS,shine*128.0f);
   }
   
   /**
	* grey color
	*/
   public void setNormalMaterial_grey()
   {   
      float amb[]={0.39f,0.39f,0.39f,1.0f};
  		float diff[]={0.50754f,0.50754f,0.50754f,1.0f};
  		float spec[]={0.508273f,0.508273f,0.508273f,1.0f};
  		float shine=51.2f;
      gl.glMaterialfv(GL_FRONT,GL_AMBIENT,amb);
      gl.glMaterialfv(GL_FRONT,GL_DIFFUSE,diff);
      gl.glMaterialfv(GL_FRONT,GL_SPECULAR,spec);
      gl.glMaterialf(GL_FRONT,GL_SHININESS,shine);
   }
   
  /**
	* black color
	*/
   public void setNormalMaterial_black()
   {
      float amb[]={0.0f,0.0f,0.0f,1.0f};
  		float diff[]={0.0f,0.0f,0.0f,1.0f};
  		float spec[]={0.2f,0.2f,0.2f,1.0f};
  		float shine=10f;
      gl.glMaterialfv(GL_FRONT,GL_AMBIENT,amb);
      gl.glMaterialfv(GL_FRONT,GL_DIFFUSE,diff);
      gl.glMaterialfv(GL_FRONT,GL_SPECULAR,spec);
      gl.glMaterialf(GL_FRONT,GL_SHININESS,shine*128.0f);
   }
    
   /**
	* orange color
	*/
   public void setNormalMaterial_orange()
   {
      float amb[]={0.2125f,0.1275f,0.054f,1.0f};
		  float diff[]={0.714f,0.4284f,0.18144f,1.0f};
      float spec[]={0.393548f,0.271906f,0.166721f,1.0f};
		  float shine=25.6f;
     	gl.glMaterialfv(GL_FRONT,GL_AMBIENT,amb);
     	gl.glMaterialfv(GL_FRONT,GL_DIFFUSE,diff);
     	gl.glMaterialfv(GL_FRONT,GL_SPECULAR,spec);
     	gl.glMaterialf(GL_FRONT,GL_SHININESS,shine*128.0f);
   }
 
   /**
	* brown color
	*/
   public void setNormalMaterial_brown()
   {
      float amb[]={0.3f,0.22f,0.09f,1.0f};
		  float diff[]={0.31f,0.22f,0.09f,1.0f};
		  float spec[]={0.29f,0.22f,0.086014f,1.0f};
		  float shine=12.8f;
      gl.glMaterialfv(GL_FRONT,GL_AMBIENT,amb);
      gl.glMaterialfv(GL_FRONT,GL_DIFFUSE,diff);
      gl.glMaterialfv(GL_FRONT,GL_SPECULAR,spec);
      gl.glMaterialf(GL_FRONT,GL_SHININESS,shine*128.0f);
   }
   
   //***************************
		//BRUN
		//***************************
      void setNormalMaterial_brown_2()
	   {
	      float amb[]={0.3f,0.32f,0.09f,1.0f};
  			float diff[]={0.31f,0.22f,0.09f,1.0f};
  			float spec[]={0.29f,0.22f,0.086014f,1.0f};
  			float shine=12.8f;
	      gl.glMaterialfv(GL_FRONT,GL_AMBIENT,amb);
	      gl.glMaterialfv(GL_FRONT,GL_DIFFUSE,diff);
	      gl.glMaterialfv(GL_FRONT,GL_SPECULAR,spec);
	      gl.glMaterialf(GL_FRONT,GL_SHININESS,shine*128.0f);
	   }

   
   /**
	* yellow color
	*/
   public void setNormalMaterial_yellow()
   {
      float amb[]={0.68f,0.63f,0.0f,1.0f};
  		float diff[]={0.63f,0.47f,0.06f,1.0f};
  		float spec[]={0.65f,0.59f,0.04f,1.0f};
  		float shine=46f;
      gl.glMaterialfv(GL_FRONT,GL_AMBIENT,amb);
      gl.glMaterialfv(GL_FRONT,GL_DIFFUSE,diff);
      gl.glMaterialfv(GL_FRONT,GL_SPECULAR,spec);
      gl.glMaterialf(GL_FRONT,GL_SHININESS,shine*128.0f);
   }
   
  /**
	* red color
	*/
   public void setNormalMaterial_red()
   {
      float amb[]={1.0f,0.0f,0.12f,1.0f};
      float diff[]={1.0f,0.0f,0.0f,1.0f};
      float spec[]={1.0f,0.0f,0.0f,1.0f};
      float shine=66f;
      gl.glMaterialfv(GL_FRONT,GL_AMBIENT,amb);
      gl.glMaterialfv(GL_FRONT,GL_DIFFUSE,diff);
      gl.glMaterialfv(GL_FRONT,GL_SPECULAR,spec);
      gl.glMaterialf(GL_FRONT,GL_SHININESS,shine*128.0f);
   }
   
   /**
	* green color
	*/
   public void setNormalMaterial_green()
   {
      float amb[]={0.0215f,0.1745f,0.0215f,1.0f};
  		float diff[]={0.07568f,0.61424f,0.07568f,1.0f};
  		float spec[]={0.633f,0.727811f,0.633f,1.0f};
  		float shine=76.8f;
      gl.glMaterialfv(GL_FRONT,GL_AMBIENT,amb);
      gl.glMaterialfv(GL_FRONT,GL_DIFFUSE,diff);
      gl.glMaterialfv(GL_FRONT,GL_SPECULAR,spec);
      gl.glMaterialf(GL_FRONT,GL_SHININESS,shine);
   }
   
   /**
	* blue color
	*/
   public void setNormalMaterial_blue()
   {
      float amb[]={0.4f,0.0f,0.79f,1.0f};
  		float diff[]={0.0f,0.509804f,0.509804f,1.0f};
  		float spec[]={0.501961f,0.501961f,0.501961f,1.0f};
  		float shine=32f;
      gl.glMaterialfv(GL_FRONT,GL_AMBIENT,amb);
      gl.glMaterialfv(GL_FRONT,GL_DIFFUSE,diff);
      gl.glMaterialfv(GL_FRONT,GL_SPECULAR,spec);
      gl.glMaterialf(GL_FRONT,GL_SHININESS,shine*128.0f);
   }
   
  /**
	* tenniscourt color
	*/
   public void setNormalMaterial_tennisbane()
   {
      float amb[]={0.74f,0.59f,0.51f,1.0f};
  		float diff[]={0.73f,0.27f,0.14f,1.0f};
  		float spec[]={0.65f,0.44f,0.3f,1.0f};
  		float shine=76.8f;
      gl.glMaterialfv(GL_FRONT,GL_AMBIENT,amb);
      gl.glMaterialfv(GL_FRONT,GL_DIFFUSE,diff);
      gl.glMaterialfv(GL_FRONT,GL_SPECULAR,spec);
      gl.glMaterialf(GL_FRONT,GL_SHININESS,shine);
   }
   
   /**
	* gold color
	*/
   public void setNormalMaterial_gold()
   {
      float amb[]={0.24725f,0.1995f,0.0745f,1.0f};
  		float diff[]={0.75164f,0.60648f,0.22648f,1.0f};
  		float spec[]={0.628281f,0.555802f,0.366065f,1.0f};
  		float shine=51.2f;
      gl.glMaterialfv(GL_FRONT,GL_AMBIENT,amb);
      gl.glMaterialfv(GL_FRONT,GL_DIFFUSE,diff);
      gl.glMaterialfv(GL_FRONT,GL_SPECULAR,spec);
      gl.glMaterialf(GL_FRONT,GL_SHININESS,shine);
   }
   
   /**
	* pink color
	*/
   void setNormalMaterial_pink()
   {   		
  		float amb[]={0.77f,0.61f,0.62f,1.0f};
  		float diff[]={0.73f,0.36f,0.59f,1.0f};
  		float spec[]={0.633f,0.42f,0.62f,1.0f};
  		float shine=84f;

      gl.glMaterialfv(GL_FRONT,GL_AMBIENT,amb);
      gl.glMaterialfv(GL_FRONT,GL_DIFFUSE,diff);
      gl.glMaterialfv(GL_FRONT,GL_SPECULAR,spec);
      gl.glMaterialf(GL_FRONT,GL_SHININESS,shine);
   }
}