import gl4java.GLContext;
import gl4java.awt.GLCanvas;
import gl4java.utils.glut.*;
import gl4java.*;

/**
* MyGLCanvas
* The main-class for OpenGL
* All the action take place here
* @author Marte Horne
* @version  1 - 2002...
*/
public class MyGLCanvas extends GLCanvas implements Runnable
{	
	//Initialize the other classes
	private Racket racket = new Racket();
	private Tennis tennis;
	private Nettet nettet = new Nettet();
	private Josefine josefine = new Josefine();
	private Josef josef = new Josef();
	private Referee referee = new Referee();
	private ColorsAndComponents colors = new ColorsAndComponents(0,0);
	private Playing playing = new Playing();
	
	//GL-components
	private GLUTFunc glut = null;   
   private long qd;
   
   private int ball = 0;
   private float racketTrans_x, racketTrans_y, racketTrans_z, racketRotate = 0.0f;
   float nett[] = new float[132];
   
   //Boolean variables
   private boolean sprett_1 = false;
   private boolean sprett_2 = false;
   private boolean sprett_3 = false;
   private boolean hit_1 = false;
   private boolean hit_2 = false;
   private boolean hit_3 = false;
   private boolean hit_4 = false;
   private boolean before = true;
   private boolean kast = false;
   private boolean josefRacket = true;
   private boolean drawLane = false;
   
   //Josefine variables
   float josefine_overarm_right[] = new float[3];
   float josefine_hand_right[] = new float[3];
   float josefine_underarm_right[] = new float[3];
   float josefine_shoulder_right[] = new float[3];
   float josefine_underarm_left[] = new float[3];
   float josefine_overarm_left[] = new float[3];
   
   //Josef variables
   float josef_overarm_right[] = new float[3];
   float josef_hand_right[] = new float[3];
   float josef_underarm_right[] = new float[3];
   float josef_shoulder_right[] = new float[3];
   
   //Referee variables
   float referee_neck[] = new float[3];
   float referee_overarm_right[] = new float[3];
   
      
	 /**
   * Konstruktr
   * @param Tennis - gets values from this class
   * @param height
   * @param widht
	*/
	public MyGLCanvas(Tennis tennis, int w, int h)
   {
     super(w, h);
     this.tennis = tennis;  
   }
   
   //Thread
   public void run()
   {
      start();
   }
   
      
	/**
	* preinit
	*/
   public void preInit()
   {
   	doubleBuffer = true;
     	stereoView = false;
      accumSize = 8;
   }
	
	/**
	* init - sets the light, smooth and depth
	*/
   public void init()
   {
      glut = new GLUTFuncLightImpl(gl, glu);      
      qd=glu.gluNewQuadric();      
      reshape(getSize().width, getSize().height);

      // prepare ligthsource
      float ambient[] = {0.6f,0.6f,0.6f,1.0f };
      float diffuse[] = {1.0f,1.0f,1.0f,1.0f };
      float position[] = {1.0f,1.0f,1.0f,0.0f };
      float lmodel_ambient[] = {0.4f,0.4f,0.4f,1.0f };

      gl.glLightfv(GL_LIGHT0, GL_AMBIENT, ambient);
      gl.glLightfv(GL_LIGHT0, GL_DIFFUSE, diffuse);
      gl.glLightfv(GL_LIGHT0, GL_POSITION, position);

      gl.glEnable(GL_LIGHT0);
      gl.glEnable(GL_LIGHTING);

      // smooth the drawing
      gl.glShadeModel(GL_SMOOTH);
      // depth sorting
      gl.glEnable(GL_DEPTH_TEST);
      gl.glDepthFunc(GL_LESS);
      // set background to light blue
      gl.glClearColor(0.7f, 0.8f, 0.9f, 1.0f);
   }
   
   
	/**
	* display
	*/
   public void display()
   {
      if (glj.gljMakeCurrent() == false)
        	return;

      showScene(true);

      glj.gljSwap();
      glj.gljFree();
   }
   
   
	/**
	* showScene - shows the GL-components
	* Calls all the classes
	* @param bRender
	*/
   void showScene(boolean bRender)
   {
      gl.glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
      gl.glClear(GL_ACCUM_BUFFER_BIT);
      gl.glLoadIdentity();
      
      // take it away
      gl.glTranslatef(0.0f,0.0f,-10.0f);
      // rotate around x-axis
      gl.glRotatef(tennis.getrotx(),1.0f,0.0f,0.0f);
      //rotate around y-axis
      gl.glRotatef(tennis.getrotz(),0.0f,1.0f,0.0f);
      
      qd=glu.gluNewQuadric();
      
      //*****************************
      //Draw out the components
      //*****************************
      gl.glTranslated(0.0f,-1.5f,0.0f);
      
      //Draws the ball-lane, if choosen in the menu
      if(tennis.getmenuEn())
      {
     		colors.setNormalMaterial_red();
      	colors.drawLane(qd, "en");
      }
      else if(tennis.getmenuTo())
      {
     		colors.setNormalMaterial_red();
      	colors.drawLane(qd, "to");
      }
      else if(tennis.getmenuTre())
      {
     		colors.setNormalMaterial_red();
      	colors.drawLane(qd, "tre");
      }
      else if(tennis.getmenuFire())
      {
     		colors.setNormalMaterial_red();
      	colors.drawLane(qd, "fire");
      }
      
      //Make Josefine
		colors.setNormalMaterial_grey();
      makeJosefine(qd);
      
      //Make Josef
      colors.setNormalMaterial_grey();
      makeJosef(qd);
      
      //Make the referee
      makeReferee(qd);
      
      //Make the court
      colors.makeCourt(qd);
      
      //Draws out the ball 
      theBall(qd);
      
      //Makes the chair
      colors.makeChair(qd);
      
      //Makes the net
      makeNett(qd);

      glu.gluDeleteQuadric(qd);
      gl.glFlush();
   }

   /**
	* starts the game :)
	*/
   public void start()
   {
      float teller, teller_1, teller_2, teller_3, teller_4, teller_5;
      kast = true;     
      teller_1 = 0.0f;
      
      //josefine kaster opp ballen
      for (int i = 0; i<(playing.getUN_kast()*3)-2; i++)
      {
         //josefine_overarm_left[0]  = teller_1;
   		//josefine.setv_overarm_left(josefine_overarm_left);
   		
	      ball = i;                  
         display();
         i = i + 2;         
         teller_1+=5;
      }
      
      kast = false;
      before = false;
   	ball = 0;
   	hit_1 = true;
   	teller = 1;
   	teller_1 = 90;
   	
   	//Josefine lfter armen for  serve...
   	for (float i = 290;i<430;i++)
   	{
   		josefine_shoulder_right[1]  = 260 + teller;
   		josefine.setv_shoulder_right(josefine_shoulder_right);
   		josefine_overarm_right[1]  = i;
   		josefine.setv_overarm_right(josefine_overarm_right);
   		josefine_underarm_right[1]  = teller;
   		josefine.setv_underarm_right(josefine_underarm_right);
   		josefine_hand_right[2]  = teller_1;
   		josefine.setv_hand_right(josefine_hand_right);	
   		display();
   	   i+=12;
   	   teller+=2;
   	   teller_1+=10;
   	}
   	   	
   	teller_1 = 0;
   	teller_2 = referee.getv_neck()[2];
            
      //Josefine server
      for (int i = 0; i<(playing.getUN_1()*3)-2; i++)
      {
	      ball = i;          
         josefine_shoulder_right[0]  = teller_1;
   		josefine.setv_shoulder_right(josefine_shoulder_right);   
   		
   		//dommeren vrir p hodet...
   		referee_neck[2]  = teller_2;
   		referee.setv_neck(referee_neck);   
   		
   				
         display();
         i = i + 2;         
         teller_1 = teller_1 + 11;
         teller_2 = teller_2 - 5.0f;
      }
      
      hit_1 = false;
      sprett_1 = true;
      teller_1 = josef.getv_overarm_right()[1];
      
      //Ballen spretter opp til Josef og han gjr seg klar
      for (int i = 0; i<(playing.getUN_2()*3)-2; i++)
      {
         josef_overarm_right[1]  = teller_1;
   		josef.setv_overarm_right(josef_overarm_right);
	      ball = i;         
         display();
         i = i + 2;         
         teller_1 = teller_1 + 6.0f;
      }
      
      sprett_1 = false;
      hit_1 = false;
      hit_2 = true;      
      teller_1 = josef.getv_overarm_right()[0]; 
      teller_2 = referee.getv_neck()[2];
      
      //Ballen blir sltt av Josef, ned i bakken 
      for (int i = 0; i<(playing.getUN_3()*3)-2; i++)
      {
         josef_overarm_right[0]  = teller_1;
   		josef.setv_overarm_right(josef_overarm_right);
   		
   		//dommeren vrir p hodet...
   		referee_neck[2]  = teller_2;
   		referee.setv_neck(referee_neck);   
   		
	      ball = i;         
         display();
         i = i + 2;
         teller_1+=2;
         teller_2 = teller_2 + 4.5f;
      }
      
      hit_2 = false;
      sprett_2 = true;
      teller_1 = josefine_overarm_right[1];
      teller_2 = josefine_underarm_right[1];
      teller_3 = josefine_hand_right[1];
      teller_4 = josef.getv_overarm_right()[1];
      
      //ballen spretter opp igjen til Josefine 
      //og hun gjr seg klar
      for (int i = 0; i<(playing.getUN_4()*3)-2; i++)
      {
	      ball = i;     
	      josefine_hand_right[2]  = teller_3;
   		josefine.setv_hand_right(josefine_hand_right);	
	      josefine_overarm_right[1]  = teller_1;
   		josefine.setv_overarm_right(josefine_overarm_right);
   		josefine_underarm_right[1]  = teller_2;
   		josefine.setv_underarm_right(josefine_underarm_right);
   		josef_overarm_right[1]  = teller_4;
   		josef.setv_overarm_right(josef_overarm_right);
         display();
         i = i + 2;
         teller_1-=5;
         teller_2-=3;
         teller_3+=12.5;
         teller_4-=5.5;
      }
      
      sprett_2 = false;
      hit_3 = true;
      
      teller_4 = josefine.getv_overarm_right()[1];
      teller_2 = referee.getv_neck()[2];
            
      //Josefine slr ballen tilbake til Josef
      for (int i = 0; i<(playing.getUN_5()*3)-2; i++)
      {      
         josefine_overarm_right[0]  = teller_4;
   		josefine.setv_overarm_right(josefine_overarm_right);
   		
   		//dommeren vrir p hodet...
   		referee_neck[2]  = teller_2;
   		referee.setv_neck(referee_neck);   
   		
	      ball = i;         
         display();
         i = i + 2;   
         teller_4-=1;      
         teller_2 = teller_2 - 5.0f;
      }
      
      hit_3 = false;
      sprett_3 = true;
      teller_1 = josef.getv_overarm_right()[1];
      teller_2 = josef.getv_overarm_right()[0];
      teller_4 = josefine.getv_overarm_right()[1];

		//ballen spretter opp til josef som gjr seg
		//klar for det avgjrende slaget      
      for (int i = 0; i<(playing.getUN_2()*3)-2; i++)
      {
         josef_overarm_right[1]  = teller_1;
   		josef.setv_overarm_right(josef_overarm_right);
   		josef_overarm_right[0]  = teller_2;
   		josef.setv_overarm_right(josef_overarm_right);
   		
   		josefine_overarm_right[1]  = teller_4;
   		josefine.setv_overarm_right(josefine_overarm_right);
   		
	      ball = i;         
         display();
         i = i + 2;         
         teller_1+=5.5f;
         teller_2-=2.2;
         teller_4+=6;
      }
      
      sprett_3 = false;
      hit_4 = true;
      teller_1 = josef.getv_overarm_right()[0];
      teller_2 = referee.getv_neck()[2];
      boolean finish = false;  
      
      //Josef taper... ;)
      for (int i = 0; i<(playing.getUN_6()*3)-2; i++)
      {
         josef_overarm_right[0]  = teller_1;
   		josef.setv_overarm_right(josef_overarm_right);
   		
   		//dommeren vrir p hodet...
   		referee_neck[2]  = teller_2;
   		referee.setv_neck(referee_neck);   
   		
	      ball = i;   
	      
	      //The net changes when the ball hits
	      if (i == 36)
	      {
	      	nettet.ctrlpoints[116] = 0.0f;
	         nettet.ctrlpoints[83] = 5.0f;
	      }
	      else if (i == 39)
	      {
	      	nettet.ctrlpoints[83] = 0.0f;
	         nettet.ctrlpoints[50] = 5.0f;
	      }
	      else if (i == 42)
	      {
	      	nettet.ctrlpoints[83] = 0.0f;
	         nettet.ctrlpoints[50] = 5.0f;
	      }
	      else if (i == 45)
	      {
	      	nettet.ctrlpoints[50] = 0.0f;
	         nettet.ctrlpoints[17] = 5.0f;
	         finish = true;
	      }
	      
	      if (finish)
	      {
	         nettet.ctrlpoints[17] = 0.0f;
	      }
	      
         display();
         i = i + 2;
         teller_1+=2;
         teller_2+=2;
      }
      
      hit_4 = false; 
      
      //Josef throws the racket in anger ;)
      throwRacket();
   }
   
   /**
	* Josef throws the racket in anger ;)
	*/
   public void throwRacket()
   {
   	
   	float teller_1, teller_2, teller_3, teller_4;
   	
   	teller_1 = josef.getv_overarm_right()[0];
   	teller_2 = josef.getv_underarm_right()[0];
   	
      //josef kaster racketen
      for (int i = 0; i<10; i++)
      {
         josef_overarm_right[0]  = teller_1;
   		josef.setv_overarm_right(josef_overarm_right);
   		josef_underarm_right[0]  = teller_2;
   		josef.setv_underarm_right(josef_underarm_right);
         display();
         i = i + 2;         
         teller_1+=20;
         teller_2+=10;
      }
      
      teller_1 = josef.getv_overarm_right()[0];
   	teller_2 = josef.getv_underarm_right()[0];
   	
      //josef kaster racketen
      for (int i = 0; i<10; i++)
      {
         josef_overarm_right[0]  = teller_1;
   		josef.setv_overarm_right(josef_overarm_right);
   		josef_underarm_right[0]  = teller_2;
   		josef.setv_underarm_right(josef_underarm_right);
         display();
         i = i + 2;         
         teller_1-=20;
         teller_2-=10;
      }
      
      teller_1 = 0.0f;
      teller_2 = 0.0f;
      teller_3 = 0.0f;
      teller_4 = 0.0f;
      
      //racketen flyr..
      for (int i = 0; i<20; i++)
      {
      	racketTrans_x = teller_1;
      	racketTrans_y = teller_2;
      	racketTrans_z = teller_3;
      	racketRotate = teller_4;
         display();
         i = i + 1;         
         teller_1 = 0.5f;
         teller_2+=1.2;
         teller_3+=0.25;
         teller_4+=15.0;
      }
      
      josefRacket = false;
   }
   
   /**
	* the line the ball follows
	* @param qd glu.gluNewQuadric()
	*/
   public void theBall(long qd)
   {
      //tegner opp hvor ballen skal g ut fra
      //bezierkurvene som er laget...
      gl.glPushMatrix();
         colors.setNormalMaterial_yellow();
         if (kast)
         {
            gl.glTranslated(playing.getkastPoints()[ball],playing.getkastPoints()[ball+1],playing.getkastPoints()[ball+2]);
         }
         else if (hit_1)
         {
            gl.glTranslated(playing.getctrlpoints_1()[ball],playing.getctrlpoints_1()[ball+1],playing.getctrlpoints_1()[ball+2]);
         }
         else if (sprett_1)
         {
      	   gl.glTranslated(playing.getctrlpoints_2()[ball],playing.getctrlpoints_2()[ball+1],playing.getctrlpoints_2()[ball+2]);
         }
         else if (hit_2)
         {
      	   gl.glTranslated(playing.getctrlpoints_3()[ball],playing.getctrlpoints_3()[ball+1],playing.getctrlpoints_3()[ball+2]);
         }
         else if (sprett_2)
         {
      	   gl.glTranslated(playing.getctrlpoints_4()[ball],playing.getctrlpoints_4()[ball+1],playing.getctrlpoints_4()[ball+2]);
         }
         else if (hit_3)
         {
      	   gl.glTranslated(playing.getctrlpoints_5()[ball],playing.getctrlpoints_5()[ball+1],playing.getctrlpoints_5()[ball+2]);
         }
         else if (sprett_3)
         {
      	   gl.glTranslated(playing.getctrlpoints_2()[ball],playing.getctrlpoints_2()[ball+1],playing.getctrlpoints_2()[ball+2]);
         }
         else if (hit_4)
         {
      	   gl.glTranslated(playing.getctrlpoints_6()[ball],playing.getctrlpoints_6()[ball+1],playing.getctrlpoints_6()[ball+2]);
         }
         else if (before)
         {
            gl.glTranslated(playing.getkastPoints()[0],playing.getkastPoints()[1],playing.getkastPoints()[2]);
         }
         else
         {
         	gl.glTranslated(playing.getctrlpoints_6()[(playing.getUN_6()*3)-3],playing.getctrlpoints_6()[(playing.getUN_6()*3)-2],playing.getctrlpoints_6()[(playing.getUN_6()*3)-1]);
         }
         
      	//the ball	
      	glu.gluSphere(qd,0.07f,30,30);
      gl.glPopMatrix();   
   }
      
   /**
	* Makes the nett
	* @param qd glu.gluNewQuadric()
	*/
   public void makeNett(long qd)
   {
   	//the bars
   	gl.glPushMatrix();
   	   gl.glRotatef(90.0f,1.0f,0.0f,0.0f);
			gl.glTranslated(0.0f,2.5f,-1.0f);
      	colors.setNormalMaterial_brown();
      	glu.gluCylinder(qd,0.06,0.06,1.0,20,20);
      	gl.glTranslated(0.0f,-5.0f,0.0f);
      	glu.gluCylinder(qd,0.06,0.06,1.0,20,20);
      gl.glPopMatrix();
      
      //the white line
      gl.glBegin(GL_POLYGON);
         colors.setNormalMaterial_white();
         gl.glVertex3f(0.0f, 1.0f,  2.5f);
         gl.glVertex3f(0.0f, 0.9f,  2.5f);
         gl.glVertex3f(0.0f, 0.9f,  -2.5f);
         gl.glVertex3f(0.0f, 1.0f,  -2.5f);
      gl.glEnd();
      
      //the net
   	colors.setNormalMaterial_black();
      gl.glRotatef(90, 0.0f, 1.0f, 0.0f);
      //map and evaluates
      gl.glMap2f(GL_MAP2_VERTEX_3,0.0f,1.0f,3,nettet.getUN(),0.0f,1.0f,3*nettet.getUN(),nettet.getVN(),nettet.getctrlpoints());
      gl.glEnable(GL_MAP2_VERTEX_3);
      gl.glMapGrid2f(40, 0.0f, 1.0f, 10, 0.0f, 1.0f);
      gl.glEnable(GL_DEPTH_TEST);
      gl.glShadeModel(GL_FLAT);	      
      gl.glEvalMesh2(GL_LINE, 0, 40, 0, 10);      
   }
   
	/**
	* makeRacket
	* @param qd glu.gluNewQuadric()
	*/
   public void makeRacket(long qd)
   {    
      gl.glPushMatrix();
   	  	gl.glRotatef(180,1.0f,0.0f,0.0f);
		   colors.setNormalMaterial_black();         
         //maps the nett in the racket			
		   gl.glMap2f(GL_MAP2_VERTEX_3,0.0f,1.0f,3,racket.getUN(),0.0f,1.0f,3*racket.getUN(),racket.getVN(),racket.getM());
		
		   gl.glEnable(GL_MAP2_VERTEX_3);
		   gl.glEnable(GL_AUTO_NORMAL);
		   gl.glEnable(GL_NORMALIZE);
		
		   gl.glMapGrid2f(20,0.0f,1.0f,20,0.0f, 1.0f);
		   gl.glFrontFace(GL_CW);		   
			//draws the lines 
		   gl.glEvalMesh2(GL_LINE, 0, 20, 0, 20);
		   gl.glFrontFace(GL_CCW);
		    
		   gl.glPushMatrix();
		   	//the handle
			   colors.setNormalMaterial_brown();
			   gl.glRotatef(90,1.0f,0.0f,0.0f);
			   gl.glTranslatef(0.0f,0.0f,-racket.getctrz6());
			   glu.gluDisk(qd,0.0f,racket.getctr6(),20,20);
			   gl.glTranslatef(0.0f,0.0f,-racket.getctrz4());
			   glu.gluCylinder(qd,racket.getctr6(),racket.getctr6(),racket.getctrz4(),20,20);
			   glu.gluDisk(qd,0.0f,racket.getctr6(),20,20);
		   gl.glPopMatrix();
		gl.glPopMatrix();	    
	}
   
   /**
	* Makes Josefine
	* @param qd glu.gluNewQuadric()
	*/
   public void makeJosefine(long qd)
   {
      //Body
      gl.glPushMatrix();
      	gl.glTranslated(josefine.getmove_josefine_x(),josefine.getmove_josefine_y(),josefine.getmove_josefine_z());	      
	      gl.glRotatef(josefine.getrotere_josefine()[0],1,0,0);
	      gl.glRotatef(josefine.getrotere_josefine()[1],0,1,0);
	      gl.glRotatef(josefine.getrotere_josefine()[2],0,0,1);
	      glu.gluSphere(qd,0.1f*josefine.getsize(),20,20);
	      
	      colors.setNormalMaterial_pink();
	      
	      //the skirt
	      gl.glPushMatrix();	   
	      	gl.glRotatef(90,1.0f,0.0f,0.0f);
	      	gl.glTranslated(0.0f,0.0f,-0.1f*josefine.getsize());
	      	colors.makeSkirt(qd);
	      gl.glPopMatrix();	   
	      
      	colors.setNormalMaterial_grey();
      	
	      gl.glPushMatrix();	      
	      	gl.glRotatef(josefine.getv_body()[0],1,0,0);
	      	gl.glRotatef(josefine.getv_body()[1],0,1,0);
	      	gl.glRotatef(josefine.getv_body()[2],0,0,1);
	      	glu.gluCylinder(qd,0.06*josefine.getsize(),0.06*josefine.getsize(),0.7*josefine.getsize(),20,20);
	      
	      	gl.glTranslated(0.0f,0.0f,0.7f*josefine.getsize());
	      	glu.gluSphere(qd,0.1f*josefine.getsize(),20,20);
      
		      //Neck and head
	      	gl.glPushMatrix();
	      		gl.glRotatef(josefine.getv_neck()[0],1,0,0);
	      		gl.glRotatef(josefine.getv_neck()[1],0,1,0);
	      		gl.glRotatef(josefine.getv_neck()[2],0,0,1);
	      		glu.gluCylinder(qd,0.035*josefine.getsize(),0.035*josefine.getsize(),0.25*josefine.getsize(),20,20);
	      		gl.glTranslated(0.0f,0.0f,0.4f*josefine.getsize());
	      		glu.gluSphere(qd,0.2f*josefine.getsize(),20,20);
	      	gl.glPopMatrix();
	      
   	
      		//left arm
	      	gl.glPushMatrix();
	      		gl.glRotatef(josefine.getv_shoulder_left()[0],1,0,0);
	      		gl.glRotatef(josefine.getv_shoulder_left()[1],0,1,0);
	      		gl.glRotatef(josefine.getv_shoulder_left()[2],0,0,1);
	      		glu.gluCylinder(qd,0.045*josefine.getsize(),0.045*josefine.getsize(),0.3*josefine.getsize(),20,20);
		      	gl.glTranslated(0.0f,0.0f,0.3f*josefine.getsize());
		      	glu.gluSphere(qd,0.07f*josefine.getsize(),20,20);
		      	gl.glRotatef(josefine.getv_overarm_left()[0],1,0,0);
	      		gl.glRotatef(josefine.getv_overarm_left()[1],0,1,0);
	      		gl.glRotatef(josefine.getv_overarm_left()[2],0,0,1);
		      	glu.gluCylinder(qd,0.045*josefine.getsize(),0.045*josefine.getsize(),0.45*josefine.getsize(),20,20);
		      	gl.glTranslated(0.0f,0.0f,0.45f*josefine.getsize());
		      	glu.gluSphere(qd,0.07f*josefine.getsize(),20,20);
		      	gl.glRotatef(josefine.getv_underarm_left()[0],1,0,0);
	      		gl.glRotatef(josefine.getv_underarm_left()[1],0,1,0);
	      		gl.glRotatef(josefine.getv_underarm_left()[2],0,0,1);
		      	glu.gluCylinder(qd,0.04*josefine.getsize(),0.04*josefine.getsize(),0.3*josefine.getsize(),20,20);
		      	gl.glTranslated(0.0f,0.0f,0.3f*josefine.getsize());
		      	glu.gluSphere(qd,0.05f*josefine.getsize(),20,20);
	      	
	      	
		      	//fingers
					gl.glRotatef(josefine.getv_hand_left()[0],1,0,0);
	      		gl.glRotatef(josefine.getv_hand_left()[1],0,1,0);
	      		gl.glRotatef(josefine.getv_hand_left()[2],0,0,1);
		      	
		      	int grad_venstre = 50;
	      		for(int i=0;i<5;i++)
	      		{
	       			gl.glPushMatrix();
						gl.glRotatef(grad_venstre,0.0f,1.0f,0.0f);
			        	glu.gluCylinder(qd,0.02*josefine.getsize(),0.02*josefine.getsize(),0.13*josefine.getsize(),20,20);
			        	gl.glTranslated(0.0f,0.0f,0.155f*josefine.getsize());
			      	glu.gluSphere(qd,0.025f*josefine.getsize(),20,20);
			      	glu.gluCylinder(qd,0.02*josefine.getsize(),0.02*josefine.getsize(),0.08*josefine.getsize(),20,20);
			        	gl.glPopMatrix();
			        	grad_venstre = grad_venstre - 20;         	
			      } 
			      
	      	
	    		gl.glPopMatrix();
	    		
	    		//right arm
	      	gl.glPushMatrix();
	      		gl.glRotatef(josefine.getv_shoulder_right()[0],1,0,0);
	      		gl.glRotatef(josefine.getv_shoulder_right()[1],0,1,0);
	      		gl.glRotatef(josefine.getv_shoulder_right()[2],0,0,1);
		      	glu.gluCylinder(qd,0.045*josefine.getsize(),0.045*josefine.getsize(),0.3*josefine.getsize(),20,20);
		      	gl.glTranslated(0.0f,0.0f,0.3f*josefine.getsize());
		      	glu.gluSphere(qd,0.07f*josefine.getsize(),20,20);
		      	gl.glRotatef(josefine.getv_overarm_right()[0],1,0,0);
	      		gl.glRotatef(josefine.getv_overarm_right()[1],0,1,0);
	      		gl.glRotatef(josefine.getv_overarm_right()[2],0,0,1);
		      	glu.gluCylinder(qd,0.045*josefine.getsize(),0.045*josefine.getsize(),0.45*josefine.getsize(),20,20);
		      	gl.glTranslated(0.0f,0.0f,0.45f*josefine.getsize());
		      	glu.gluSphere(qd,0.07f*josefine.getsize(),20,20);
		      	gl.glRotatef(josefine.getv_underarm_right()[0],1,0,0);
	      		gl.glRotatef(josefine.getv_underarm_right()[1],0,1,0);
	      		gl.glRotatef(josefine.getv_underarm_right()[2],0,0,1);
		      	glu.gluCylinder(qd,0.04*josefine.getsize(),0.04*josefine.getsize(),0.3*josefine.getsize(),20,20);
		      	gl.glTranslated(0.0f,0.0f,0.3f*josefine.getsize());
		      	glu.gluSphere(qd,0.05f*josefine.getsize(),20,20);

					//fingers
					gl.glRotatef(josefine.getv_hand_right()[0],1,0,0);
	      		gl.glRotatef(josefine.getv_hand_right()[1],0,1,0);
	      		gl.glRotatef(josefine.getv_hand_right()[2],0,0,1);
	      		
		        	int grad_hoyre = 50;
	      		for(int i=0;i<5;i++)
	      		{
	       			gl.glPushMatrix();
					   gl.glRotatef(grad_hoyre,0.0f,1.0f,0.0f);
			         glu.gluCylinder(qd,0.02*josefine.getsize(),0.02*josefine.getsize(),0.13*josefine.getsize(),20,20);
			         gl.glTranslated(0.0f,0.0f,0.155f*josefine.getsize());
			      	glu.gluSphere(qd,0.025f*josefine.getsize(),20,20);
			      	gl.glRotatef(-30,1.0f,0.0f,0.0f);
			      	glu.gluCylinder(qd,0.02*josefine.getsize(),0.02*josefine.getsize(),0.08*josefine.getsize(),20,20);
			        gl.glPopMatrix();
			        grad_hoyre = grad_hoyre - 20;         	
			      } 
			      
			      if (playing.getdrawRacket())
			      {
   			      //the racket
   			      gl.glPushMatrix();
   			         gl.glRotatef(90,0.0f,0.0f,1.0f);
   			         gl.glRotatef(90,0.0f,1.0f,0.0f);
   			         gl.glRotatef(90,0.0f,0.0f,1.0f);
   			         gl.glTranslated(0.0f,racket.getRacket()+racket.getctrz4(),0.0f);
   			         makeRacket(qd);
   			      gl.glPopMatrix();
			      }
			      
			      colors.setNormalMaterial_grey();
	      	
      		gl.glPopMatrix();

   		gl.glPopMatrix();
   	
      	//left leg
	      gl.glPushMatrix();
	      	gl.glRotatef(josefine.getv_hip_left()[1],0,1,0);
	      	gl.glRotatef(josefine.getv_hip_left()[0],1,0,0);
	      	gl.glRotatef(josefine.getv_hip_left()[2],0,0,1);
	      	glu.gluCylinder(qd,0.045*josefine.getsize(),0.045*josefine.getsize(),0.2*josefine.getsize(),20,20);
	      	gl.glTranslated(0.0f,0.0f,0.2f*josefine.getsize());
		      glu.gluSphere(qd,0.07f*josefine.getsize(),20,20);
		      gl.glRotatef(josefine.getv_thigh_left()[0],1,0,0);
	      	gl.glRotatef(josefine.getv_thigh_left()[1],0,1,0);
	      	gl.glRotatef(josefine.getv_thigh_left()[2],0,0,1);
		      glu.gluCylinder(qd,0.045*josefine.getsize(),0.045*josefine.getsize(),0.5*josefine.getsize(),20,20);
		      gl.glTranslated(0.0f,0.0f,0.5f*josefine.getsize());
		      glu.gluSphere(qd,0.07f*josefine.getsize(),20,20);
		      gl.glRotatef(josefine.getv_leg_left()[0],1,0,0);
	      	gl.glRotatef(josefine.getv_leg_left()[1],0,1,0);
	      	gl.glRotatef(josefine.getv_leg_left()[2],0,0,1);
		      glu.gluCylinder(qd,0.045*josefine.getsize(),0.045*josefine.getsize(),0.45*josefine.getsize(),20,20);
		      gl.glTranslated(0.0f,0.0f,0.45f*josefine.getsize());
		      glu.gluSphere(qd,0.07f*josefine.getsize(),20,20);
		      gl.glRotatef(josefine.getv_foot_left()[0],1,0,0);
	      	gl.glRotatef(josefine.getv_foot_left()[1],0,1,0);
	      	gl.glRotatef(josefine.getv_foot_left()[2],0,0,1);
		      glu.gluCylinder(qd,0.065*josefine.getsize(),0.0*josefine.getsize(),0.3*josefine.getsize(),20,20);
	      gl.glPopMatrix();
      
	      //right leg
	      gl.glPushMatrix();
	      	gl.glRotatef(josefine.getv_hip_right()[1],0,1,0);
	      	gl.glRotatef(josefine.getv_hip_right()[0],1,0,0);
	      	gl.glRotatef(josefine.getv_hip_right()[2],0,0,1);
	      	glu.gluCylinder(qd,0.045*josefine.getsize(),0.045*josefine.getsize(),0.2*josefine.getsize(),20,20);
	      	gl.glTranslated(0.0f,0.0f,0.2f*josefine.getsize());
		      glu.gluSphere(qd,0.07f*josefine.getsize(),20,20);
		      gl.glRotatef(josefine.getv_thigh_right()[0],1,0,0);
	      	gl.glRotatef(josefine.getv_thigh_right()[1],0,1,0);
	      	gl.glRotatef(josefine.getv_thigh_right()[2],0,0,1);
		      glu.gluCylinder(qd,0.045*josefine.getsize(),0.045*josefine.getsize(),0.5*josefine.getsize(),20,20);
		      gl.glTranslated(0.0f,0.0f,0.5f*josefine.getsize());
		      glu.gluSphere(qd,0.07f*josefine.getsize(),20,20);
		      gl.glRotatef(josefine.getv_leg_right()[0],1,0,0);
	      	gl.glRotatef(josefine.getv_leg_right()[1],0,1,0);
	      	gl.glRotatef(josefine.getv_leg_right()[2],0,0,1);
		      glu.gluCylinder(qd,0.045*josefine.getsize(),0.045*josefine.getsize(),0.45*josefine.getsize(),20,20);
		      gl.glTranslated(0.0f,0.0f,0.45f*josefine.getsize());
		      glu.gluSphere(qd,0.07f*josefine.getsize(),20,20);
		      gl.glRotatef(josefine.getv_foot_right()[0],1,0,0);
	      	gl.glRotatef(josefine.getv_foot_right()[1],0,1,0);
	      	gl.glRotatef(josefine.getv_foot_right()[2],0,0,1);
		      glu.gluCylinder(qd,0.065*josefine.getsize(),0.0*josefine.getsize(),0.3*josefine.getsize(),20,20);
	      gl.glPopMatrix();
   	gl.glPopMatrix();
   }
   
   
   
   /**
	* Makes Josef
	* @param qd glu.gluNewQuadric()
	*/
   public void makeJosef(long qd)
   {	
      //body
      gl.glPushMatrix();
      
      	gl.glTranslated(josef.getmove_josef_x(),josef.getmove_josef_y(),josef.getmove_josef_z());
      	
      	gl.glRotatef(josef.getrotere_josef()[0],1,0,0);
	      gl.glRotatef(josef.getrotere_josef()[1],0,1,0);
	      gl.glRotatef(josef.getrotere_josef()[2],0,0,1);
	      glu.gluSphere(qd,0.1f*josef.getsize(),20,20);
      
	      gl.glPushMatrix();	      
	      	gl.glRotatef(josef.getv_body()[0],1,0,0);
	      	gl.glRotatef(josef.getv_body()[1],0,1,0);
	      	gl.glRotatef(josef.getv_body()[2],0,0,1);
	      	glu.gluCylinder(qd,0.06*josef.getsize(),0.06*josef.getsize(),0.7*josef.getsize(),20,20);
	      
	      	gl.glTranslated(0.0f,0.0f,0.7f*josef.getsize());
	      	glu.gluSphere(qd,0.1f*josef.getsize(),20,20);
      
      
		      //neck and head
	      	gl.glPushMatrix();
	      		gl.glRotatef(josef.getv_neck()[0],1,0,0);
	      		gl.glRotatef(josef.getv_neck()[1],0,1,0);
	      		gl.glRotatef(josef.getv_neck()[2],0,0,1);
	      		glu.gluCylinder(qd,0.035*josef.getsize(),0.035*josef.getsize(),0.25*josef.getsize(),20,20);
	      		gl.glTranslated(0.0f,0.0f,0.4f*josef.getsize());
	      		glu.gluSphere(qd,0.2f*josef.getsize(),30,30);
	      	gl.glPopMatrix();
   	
      		//left arm
	      	gl.glPushMatrix();
	      		gl.glRotatef(josef.getv_shoulder_left()[0],1,0,0);
	      		gl.glRotatef(josef.getv_shoulder_left()[1],0,1,0);
	      		gl.glRotatef(josef.getv_shoulder_left()[2],0,0,1);
	      		glu.gluCylinder(qd,0.045*josef.getsize(),0.045*josef.getsize(),0.3*josef.getsize(),20,20);
		      	gl.glTranslated(0.0f,0.0f,0.3f*josef.getsize());
		      	glu.gluSphere(qd,0.07f*josef.getsize(),20,20);
		      	gl.glRotatef(josef.getv_overarm_left()[0],1,0,0);
	      		gl.glRotatef(josef.getv_overarm_left()[1],0,1,0);
	      		gl.glRotatef(josef.getv_overarm_left()[2],0,0,1);
		      	glu.gluCylinder(qd,0.045*josef.getsize(),0.045*josef.getsize(),0.45*josef.getsize(),20,20);
		      	gl.glTranslated(0.0f,0.0f,0.45f*josef.getsize());
		      	glu.gluSphere(qd,0.07f*josef.getsize(),20,20);
		      	gl.glRotatef(josef.getv_underarm_left()[0],1,0,0);
	      		gl.glRotatef(josef.getv_underarm_left()[1],0,1,0);
	      		gl.glRotatef(josef.getv_underarm_left()[2],0,0,1);
		      	glu.gluCylinder(qd,0.04*josef.getsize(),0.04*josef.getsize(),0.3*josef.getsize(),20,20);
		      	gl.glTranslated(0.0f,0.0f,0.3f*josef.getsize());
		      	glu.gluSphere(qd,0.05f*josef.getsize(),20,20);
	      	
	      	
		      	gl.glRotatef(90.0f,0.0f,0.0f,1.0f);
		      	
		      	int grad_venstre = 50;
	      		for(int i=0;i<5;i++)
	      		{
	       			gl.glPushMatrix();
						gl.glRotatef(grad_venstre,0.0f,1.0f,0.0f);
			        	glu.gluCylinder(qd,0.02*josef.getsize(),0.02*josef.getsize(),0.13*josef.getsize(),20,20);
			        	gl.glTranslated(0.0f,0.0f,0.155f*josef.getsize());
			      	glu.gluSphere(qd,0.025f*josef.getsize(),20,20);
			      	glu.gluCylinder(qd,0.02*josef.getsize(),0.02*josef.getsize(),0.08*josef.getsize(),20,20);
			        	gl.glPopMatrix();
			        	grad_venstre = grad_venstre - 20;         	
			      } 
			      
	    		gl.glPopMatrix();
	    	
	    		//right arm
	      	gl.glPushMatrix();
	      		gl.glRotatef(josef.getv_shoulder_right()[0],1,0,0);
	      		gl.glRotatef(josef.getv_shoulder_right()[1],0,1,0);
	      		gl.glRotatef(josef.getv_shoulder_right()[2],0,0,1);
		      	glu.gluCylinder(qd,0.045*josef.getsize(),0.045*josef.getsize(),0.3*josef.getsize(),20,20);
		      	gl.glTranslated(0.0f,0.0f,0.3f*josef.getsize());
		      	glu.gluSphere(qd,0.07f*josef.getsize(),20,20);
		      	gl.glRotatef(josef.getv_overarm_right()[0],1,0,0);
	      		gl.glRotatef(josef.getv_overarm_right()[1],0,1,0);
	      		gl.glRotatef(josef.getv_overarm_right()[2],0,0,1);
		      	glu.gluCylinder(qd,0.045*josef.getsize(),0.045*josef.getsize(),0.45*josef.getsize(),20,20);
		      	gl.glTranslated(0.0f,0.0f,0.45f*josef.getsize());
		      	glu.gluSphere(qd,0.07f*josef.getsize(),20,20);
		      	gl.glRotatef(josef.getv_underarm_right()[0],1,0,0);
	      		gl.glRotatef(josef.getv_underarm_right()[1],0,1,0);
	      		gl.glRotatef(josef.getv_underarm_right()[2],0,0,1);
		      	glu.gluCylinder(qd,0.04*josef.getsize(),0.04*josef.getsize(),0.3*josef.getsize(),20,20);
		      	gl.glTranslated(0.0f,0.0f,0.3f*josef.getsize());
		      	glu.gluSphere(qd,0.05f*josef.getsize(),20,20);

					gl.glRotatef(josef.getv_hand_right()[0],1,0,0);
	      		gl.glRotatef(josef.getv_hand_right()[1],0,1,0);
	      		gl.glRotatef(josef.getv_hand_right()[2],0,0,1);
		      	
		      	int grad_hoyre = 50;
	      		for(int i=0;i<5;i++)
	      		{
	       			gl.glPushMatrix();
					gl.glRotatef(grad_hoyre,0.0f,1.0f,0.0f);
			        glu.gluCylinder(qd,0.02*josef.getsize(),0.02*josef.getsize(),0.13*josef.getsize(),20,20);
			        gl.glTranslated(0.0f,0.0f,0.155f*josef.getsize());
			      	glu.gluSphere(qd,0.025f*josef.getsize(),20,20);
			      	gl.glRotatef(-30,1.0f,0.0f,0.0f);
			      	glu.gluCylinder(qd,0.02*josef.getsize(),0.02*josef.getsize(),0.08*josef.getsize(),20,20);
			        gl.glPopMatrix();
			        grad_hoyre = grad_hoyre - 20;         	
			     } 
			      
			      if (josefRacket)
			      {
   			      //the racket
   			      gl.glPushMatrix();
   			         gl.glRotatef(90,1.0f,0.0f,0.0f);
   			         gl.glTranslated(0.0f,racket.getRacket()+racket.getctrz5(),0.0f);
   			         gl.glTranslated(-0.1f*josef.getsize()+0.1,0.0f,0.0f);
   			         gl.glRotatef(racketRotate,0.0f,1.0f,0.0f);
   			         gl.glTranslated(racketTrans_x,0.0f,0.0f);
   			         gl.glTranslated(0.0f,racketTrans_y,0.0f);
   			         gl.glTranslated(0.0f,0.0f,racketTrans_z);
   			         
   			         makeRacket(qd);
   			      gl.glPopMatrix();
			      }
			      
			      colors.setNormalMaterial_grey();
		         
	      	
      		gl.glPopMatrix();

   		gl.glPopMatrix();
   	
      	//left leg
	      gl.glPushMatrix();
	      	gl.glRotatef(josef.getv_hip_left()[1],0,1,0);
	      	gl.glRotatef(josef.getv_hip_left()[0],1,0,0);
	      	gl.glRotatef(josef.getv_hip_left()[2],0,0,1);
	      	glu.gluCylinder(qd,0.045*josef.getsize(),0.045*josef.getsize(),0.2*josef.getsize(),20,20);
	      	gl.glTranslated(0.0f,0.0f,0.2f*josef.getsize());
		      glu.gluSphere(qd,0.07f*josef.getsize(),20,20);
		      gl.glRotatef(josef.getv_thigh_left()[0],1,0,0);
	      	gl.glRotatef(josef.getv_thigh_left()[1],0,1,0);
	      	gl.glRotatef(josef.getv_thigh_left()[2],0,0,1);
		      glu.gluCylinder(qd,0.045*josef.getsize(),0.045*josef.getsize(),0.5*josef.getsize(),20,20);
		      gl.glTranslated(0.0f,0.0f,0.5f*josef.getsize());
		      glu.gluSphere(qd,0.07f*josef.getsize(),20,20);
		      gl.glRotatef(josef.getv_leg_left()[0],1,0,0);
	      	gl.glRotatef(josef.getv_leg_left()[1],0,1,0);
	      	gl.glRotatef(josef.getv_leg_left()[2],0,0,1);
		      glu.gluCylinder(qd,0.045*josef.getsize(),0.045*josef.getsize(),0.45*josef.getsize(),20,20);
		      gl.glTranslated(0.0f,0.0f,0.45f*josef.getsize());
		      glu.gluSphere(qd,0.07f*josef.getsize(),20,20);
		      gl.glRotatef(josef.getv_foot_left()[0],1,0,0);
	      	gl.glRotatef(josef.getv_foot_left()[1],0,1,0);
	      	gl.glRotatef(josef.getv_foot_left()[2],0,0,1);

		      glu.gluCylinder(qd,0.065*josef.getsize(),0.0*josef.getsize(),0.3*josef.getsize(),20,20);
	      gl.glPopMatrix();
      
	      //righth leg
	      gl.glPushMatrix();
	      	gl.glRotatef(josef.getv_hip_right()[1],0,1,0);
	      	gl.glRotatef(josef.getv_hip_right()[0],1,0,0);
	      	gl.glRotatef(josef.getv_hip_right()[2],0,0,1);
	      	glu.gluCylinder(qd,0.045*josef.getsize(),0.045*josef.getsize(),0.2*josef.getsize(),20,20);
	      	gl.glTranslated(0.0f,0.0f,0.2f*josef.getsize());
		      glu.gluSphere(qd,0.07f*josef.getsize(),20,20);
		      gl.glRotatef(josef.getv_thigh_right()[0],1,0,0);
	      	gl.glRotatef(josef.getv_thigh_right()[1],0,1,0);
	      	gl.glRotatef(josef.getv_thigh_right()[2],0,0,1);
		      glu.gluCylinder(qd,0.045*josef.getsize(),0.045*josef.getsize(),0.5*josef.getsize(),20,20);
		      gl.glTranslated(0.0f,0.0f,0.5f*josef.getsize());
		      glu.gluSphere(qd,0.07f*josef.getsize(),20,20);
		      gl.glRotatef(josef.getv_leg_right()[0],1,0,0);
	      	gl.glRotatef(josef.getv_leg_right()[1],0,1,0);
	      	gl.glRotatef(josef.getv_leg_right()[2],0,0,1);
		      glu.gluCylinder(qd,0.045*josef.getsize(),0.045*josef.getsize(),0.45*josef.getsize(),20,20);
		      gl.glTranslated(0.0f,0.0f,0.45f*josef.getsize());
		      glu.gluSphere(qd,0.07f*josef.getsize(),20,20);
		      gl.glRotatef(josef.getv_foot_right()[0],1,0,0);
	      	gl.glRotatef(josef.getv_foot_right()[1],0,1,0);
	      	gl.glRotatef(josef.getv_foot_right()[2],0,0,1);
		      glu.gluCylinder(qd,0.065*josef.getsize(),0.0*josef.getsize(),0.3*josef.getsize(),20,20);
	      gl.glPopMatrix();
   	gl.glPopMatrix();
   }
 
    /**
	* Reshape
	* @param w
	* @param h
	*/
   public void reshape(int w, int h)
   {
   	gl.glViewport(0, 0, w, h);
      gl.glMatrixMode(GL_PROJECTION);
      gl.glLoadIdentity();
      glu.gluPerspective( 45.0, (float) w/h, 1.0, 500.0 );
      gl.glMatrixMode(GL_MODELVIEW);
   }
   
   
   /**
	* Makes Referee
	* @param qd glu.gluNewQuadric()
	*/
   public void makeReferee(long qd)
   {	
      //body
      gl.glPushMatrix();
      
      	gl.glTranslated(referee.getmove_referee_x(),referee.getmove_referee_y(),referee.getmove_referee_z());
      	
      	gl.glRotatef(referee.getrotere_referee()[0],1,0,0);
	      gl.glRotatef(referee.getrotere_referee()[1],0,1,0);
	      gl.glRotatef(referee.getrotere_referee()[2],0,0,1);
	      glu.gluSphere(qd,0.1f*referee.getsize(),20,20);
      
	      gl.glPushMatrix();	      
	      	gl.glRotatef(referee.getv_body()[0],1,0,0);
	      	gl.glRotatef(referee.getv_body()[1],0,1,0);
	      	gl.glRotatef(referee.getv_body()[2],0,0,1);
	      	glu.gluCylinder(qd,0.06*referee.getsize(),0.06*referee.getsize(),0.7*referee.getsize(),20,20);
	      
	      	gl.glTranslated(0.0f,0.0f,0.7f*referee.getsize());
	      	glu.gluSphere(qd,0.1f*referee.getsize(),20,20);
      
      
		      //neck and head
	      	gl.glPushMatrix();
	      		gl.glRotatef(referee.getv_neck()[0],1,0,0);
	      		gl.glRotatef(referee.getv_neck()[1],0,1,0);
	      		gl.glRotatef(referee.getv_neck()[2],0,0,1);
	      		glu.gluCylinder(qd,0.035*referee.getsize(),0.035*referee.getsize(),0.25*referee.getsize(),20,20);
	      		gl.glTranslated(0.0f,0.0f,0.4f*referee.getsize());
	      		glu.gluSphere(qd,0.2f*referee.getsize(),30,30);
	      		
	      		gl.glPushMatrix();
	      		   gl.glRotatef(90.0f,1.0f,0.0f,0.0f);
	      		   gl.glTranslated(0.0f,-0.5f,0.0f);
	      		   colors.makeHat(qd);
	      		gl.glPopMatrix();
	      		
	      		colors.setNormalMaterial_blue();
	      		gl.glTranslated(0.08f,-0.2f*referee.getsize(),0.0f);
	      		glu.gluSphere(qd,0.04f*referee.getsize(),30,30);
	      		
	      		gl.glTranslated(-0.16f,0.0f,0.0f);
	      		glu.gluSphere(qd,0.04f*referee.getsize(),30,30);
	      		
	      	gl.glPopMatrix();
   	
   	      colors.setNormalMaterial_grey();
   	
      		//left arm
	      	gl.glPushMatrix();
	      		gl.glRotatef(referee.getv_shoulder_left()[0],1,0,0);
	      		gl.glRotatef(referee.getv_shoulder_left()[1],0,1,0);
	      		gl.glRotatef(referee.getv_shoulder_left()[2],0,0,1);
	      		glu.gluCylinder(qd,0.045*referee.getsize(),0.045*referee.getsize(),0.3*referee.getsize(),20,20);
		      	gl.glTranslated(0.0f,0.0f,0.3f*referee.getsize());
		      	glu.gluSphere(qd,0.07f*referee.getsize(),20,20);
		      	gl.glRotatef(referee.getv_overarm_left()[0],1,0,0);
	      		gl.glRotatef(referee.getv_overarm_left()[1],0,1,0);
	      		gl.glRotatef(referee.getv_overarm_left()[2],0,0,1);
		      	glu.gluCylinder(qd,0.045*referee.getsize(),0.045*referee.getsize(),0.45*referee.getsize(),20,20);
		      	gl.glTranslated(0.0f,0.0f,0.45f*referee.getsize());
		      	glu.gluSphere(qd,0.07f*referee.getsize(),20,20);
		      	gl.glRotatef(referee.getv_underarm_left()[0],1,0,0);
	      		gl.glRotatef(referee.getv_underarm_left()[1],0,1,0);
	      		gl.glRotatef(referee.getv_underarm_left()[2],0,0,1);
		      	glu.gluCylinder(qd,0.04*referee.getsize(),0.04*referee.getsize(),0.3*referee.getsize(),20,20);
		      	gl.glTranslated(0.0f,0.0f,0.3f*referee.getsize());
		      	glu.gluSphere(qd,0.05f*referee.getsize(),20,20);
	      	
	      	
		      	gl.glRotatef(90.0f,0.0f,0.0f,1.0f);
		      	
		      	int grad_venstre = 50;
	      		for(int i=0;i<5;i++)
	      		{
	       			gl.glPushMatrix();
						gl.glRotatef(grad_venstre,0.0f,1.0f,0.0f);
			        	glu.gluCylinder(qd,0.02*referee.getsize(),0.02*referee.getsize(),0.13*referee.getsize(),20,20);
			        	gl.glTranslated(0.0f,0.0f,0.155f*referee.getsize());
			      	glu.gluSphere(qd,0.025f*referee.getsize(),20,20);
			      	glu.gluCylinder(qd,0.02*referee.getsize(),0.02*referee.getsize(),0.08*referee.getsize(),20,20);
			        	gl.glPopMatrix();
			        	grad_venstre = grad_venstre - 20;         	
			      } 
			      
	    		gl.glPopMatrix();
	    	
	    		//right arm
	      	gl.glPushMatrix();
	      		gl.glRotatef(referee.getv_shoulder_right()[0],1,0,0);
	      		gl.glRotatef(referee.getv_shoulder_right()[1],0,1,0);
	      		gl.glRotatef(referee.getv_shoulder_right()[2],0,0,1);
		      	glu.gluCylinder(qd,0.045*referee.getsize(),0.045*referee.getsize(),0.3*referee.getsize(),20,20);
		      	gl.glTranslated(0.0f,0.0f,0.3f*referee.getsize());
		      	glu.gluSphere(qd,0.07f*referee.getsize(),20,20);
		      	gl.glRotatef(referee.getv_overarm_right()[0],1,0,0);
	      		gl.glRotatef(referee.getv_overarm_right()[1],0,1,0);
	      		gl.glRotatef(referee.getv_overarm_right()[2],0,0,1);
		      	glu.gluCylinder(qd,0.045*referee.getsize(),0.045*referee.getsize(),0.45*referee.getsize(),20,20);
		      	gl.glTranslated(0.0f,0.0f,0.45f*referee.getsize());
		      	glu.gluSphere(qd,0.07f*referee.getsize(),20,20);
		      	gl.glRotatef(referee.getv_underarm_right()[0],1,0,0);
	      		gl.glRotatef(referee.getv_underarm_right()[1],0,1,0);
	      		gl.glRotatef(referee.getv_underarm_right()[2],0,0,1);
		      	glu.gluCylinder(qd,0.04*referee.getsize(),0.04*referee.getsize(),0.3*referee.getsize(),20,20);
		      	gl.glTranslated(0.0f,0.0f,0.3f*referee.getsize());
		      	glu.gluSphere(qd,0.05f*referee.getsize(),20,20);

					gl.glRotatef(referee.getv_hand_right()[0],1,0,0);
	      		gl.glRotatef(referee.getv_hand_right()[1],0,1,0);
	      		gl.glRotatef(referee.getv_hand_right()[2],0,0,1);
		      	
		      	int grad_hoyre = 50;
	      		for(int i=0;i<5;i++)
	      		{
	       			gl.glPushMatrix();
						gl.glRotatef(grad_hoyre,0.0f,1.0f,0.0f);
			        	glu.gluCylinder(qd,0.02*referee.getsize(),0.02*referee.getsize(),0.13*referee.getsize(),20,20);
			        	gl.glTranslated(0.0f,0.0f,0.155f*referee.getsize());
			      	glu.gluSphere(qd,0.025f*referee.getsize(),20,20);
			      	gl.glRotatef(-30,1.0f,0.0f,0.0f);
			      	glu.gluCylinder(qd,0.02*referee.getsize(),0.02*referee.getsize(),0.08*referee.getsize(),20,20);
			        	gl.glPopMatrix();
			        	grad_hoyre = grad_hoyre - 20;         	
			     	} 
		         
	      	
      		gl.glPopMatrix();

   		gl.glPopMatrix();
   	
      	//left leg
	      gl.glPushMatrix();
	      	gl.glRotatef(referee.getv_hip_left()[1],0,1,0);
	      	gl.glRotatef(referee.getv_hip_left()[0],1,0,0);
	      	gl.glRotatef(referee.getv_hip_left()[2],0,0,1);
	      	glu.gluCylinder(qd,0.045*referee.getsize(),0.045*referee.getsize(),0.2*referee.getsize(),20,20);
	      	gl.glTranslated(0.0f,0.0f,0.2f*referee.getsize());
		      glu.gluSphere(qd,0.07f*referee.getsize(),20,20);
		      gl.glRotatef(referee.getv_thigh_left()[0],1,0,0);
	      	gl.glRotatef(referee.getv_thigh_left()[1],0,1,0);
	      	gl.glRotatef(referee.getv_thigh_left()[2],0,0,1);
		      glu.gluCylinder(qd,0.045*referee.getsize(),0.045*referee.getsize(),0.5*referee.getsize(),20,20);
		      gl.glTranslated(0.0f,0.0f,0.5f*referee.getsize());
		      glu.gluSphere(qd,0.07f*referee.getsize(),20,20);
		      gl.glRotatef(referee.getv_leg_left()[0],1,0,0);
	      	gl.glRotatef(referee.getv_leg_left()[1],0,1,0);
	      	gl.glRotatef(referee.getv_leg_left()[2],0,0,1);
		      glu.gluCylinder(qd,0.045*referee.getsize(),0.045*referee.getsize(),0.45*referee.getsize(),20,20);
		      gl.glTranslated(0.0f,0.0f,0.45f*referee.getsize());
		      glu.gluSphere(qd,0.07f*referee.getsize(),20,20);
		      gl.glRotatef(referee.getv_foot_left()[0],1,0,0);
	      	gl.glRotatef(referee.getv_foot_left()[1],0,1,0);
	      	gl.glRotatef(referee.getv_foot_left()[2],0,0,1);

		      glu.gluCylinder(qd,0.065*referee.getsize(),0.0*referee.getsize(),0.3*referee.getsize(),20,20);
	      gl.glPopMatrix();
      
	      //righth leg
	      gl.glPushMatrix();
	      	gl.glRotatef(referee.getv_hip_right()[1],0,1,0);
	      	gl.glRotatef(referee.getv_hip_right()[0],1,0,0);
	      	gl.glRotatef(referee.getv_hip_right()[2],0,0,1);
	      	glu.gluCylinder(qd,0.045*referee.getsize(),0.045*referee.getsize(),0.2*referee.getsize(),20,20);
	      	gl.glTranslated(0.0f,0.0f,0.2f*referee.getsize());
		      glu.gluSphere(qd,0.07f*referee.getsize(),20,20);
		      gl.glRotatef(referee.getv_thigh_right()[0],1,0,0);
	      	gl.glRotatef(referee.getv_thigh_right()[1],0,1,0);
	      	gl.glRotatef(referee.getv_thigh_right()[2],0,0,1);
		      glu.gluCylinder(qd,0.045*referee.getsize(),0.045*referee.getsize(),0.5*referee.getsize(),20,20);
		      gl.glTranslated(0.0f,0.0f,0.5f*referee.getsize());
		      glu.gluSphere(qd,0.07f*referee.getsize(),20,20);
		      gl.glRotatef(referee.getv_leg_right()[0],1,0,0);
	      	gl.glRotatef(referee.getv_leg_right()[1],0,1,0);
	      	gl.glRotatef(referee.getv_leg_right()[2],0,0,1);
		      glu.gluCylinder(qd,0.045*referee.getsize(),0.045*referee.getsize(),0.45*referee.getsize(),20,20);
		      gl.glTranslated(0.0f,0.0f,0.45f*referee.getsize());
		      glu.gluSphere(qd,0.07f*referee.getsize(),20,20);
		      gl.glRotatef(referee.getv_foot_right()[0],1,0,0);
	      	gl.glRotatef(referee.getv_foot_right()[1],0,1,0);
	      	gl.glRotatef(referee.getv_foot_right()[2],0,0,1);
		      glu.gluCylinder(qd,0.065*referee.getsize(),0.0*referee.getsize(),0.3*referee.getsize(),20,20);
	      gl.glPopMatrix();
   	gl.glPopMatrix();
   }
}   