/**
* The racket
* Contains the control-points 
* to the net in the racket
* @author Marte Horne
* @version  1 - 2002...
*/
public class Racket
{
   private float RACKET = 0.4f;
   private int UN =5;
	 private int VN =7;

   private float ctr1=0.3f*RACKET;
   private float ctr2=0.7f*RACKET;
   private float ctr3=0.4f*RACKET;
   private float ctr4=0.15f*RACKET;
   private float ctr5=0.1f*RACKET;
   private float ctr6=0.05f*RACKET;
   
   /** offset along z */
   private float ctrz1=0.0f*RACKET;
   private float ctrz2=0.3f*RACKET;
   private float ctrz3=1.0f*RACKET;
   private float ctrz4=0.85f*RACKET;
   private float ctrz5=0.9f*RACKET;
   private float ctrz6=RACKET*1.2f;
   
   //Values to the racket
   private float M[] =
	 {   		
		  0.0f,	0.0f, 0.0f,		
		  0.0f,	0.0f, 0.0f,	
      0.0f,	0.0f, 0.0f,		
      0.0f,	0.0f, 0.0f,	
      0.0f, 0.0f, 0.0f,	

  		ctr1,	ctrz1, 0.0f,	
  		0.0f,	ctrz1, 0.0f,
      0.0f,	ctrz1, 0.0f,	
      0.0f,	ctrz1, 0.0f,
      -ctr1, ctrz1, 0.0f,

      ctr2,	ctrz2, 0.0f,	
      0.0f,	ctrz2, 0.0f,	
      0.0f,	ctrz2, 0.0f,	
      0.0f,	ctrz2, 0.0f,	
      -ctr2,ctrz2, 0.0f,	
      
      ctr3,	ctrz3, 0.0f,	
      ctr3,	ctrz3, 0.0f,
      0.0f,	ctrz3, 0.0f,	
      -ctr3,ctrz3, 0.0f,
      -ctr3,ctrz3, 0.0f,
      
      ctr4,	ctrz4, 0.0f,	
      ctr4,	ctrz4, 0.0f,
      0.0f, ctrz4, 0.0f,	
      -ctr4,ctrz4, 0.0f,
      -ctr4,ctrz4, 0.0f,
      
      ctr5,	ctrz5, 0.0f,	
      ctr5,	ctrz5, 0.0f,
      0.0f,	ctrz5, 0.0f,	
      -ctr5,ctrz5, 0.0f,
      -ctr5,ctrz5, 0.0f,
      
      ctr6,	ctrz6,	0.0f,	
      0.0f,	ctrz6,	0.0f,
      0.0f,	ctrz6,	0.0f,	
      0.0f,	ctrz6,	0.0f,
      -ctr6,ctrz6,	0.0f,
   };
	
	
	/**
	* The size of the racket
	* @return RACKET
	*/
	public float getRacket()
	{
		return RACKET;
	}
	
	/**
	* getUN
	* @return UN
	*/
	public int getUN()
	{
		return UN;
	}
	
	/**
	* getVN
	* @return VN
	*/
	public int getVN()
	{
		return VN;
	}
	
	/**
	* get ctr1
	* @return ctr1
	*/
	public float getctr1()
	{
		return ctr1;
	}
	
	/**
	* get ctr2
	* @return ctr2
	*/
	public float getctr2()
	{
		return ctr2;
	}
	
	/**
	* get ctr3
	* @return ctr3
	*/
	public float getctr3()
	{
		return ctr3;
	}
	
	/**
	* get ctr4
	* @return ctr4
	*/
	public float getctr4()
	{
		return ctr4;
	}
	
	/**
	* get ctr5
	* @return ctr5
	*/
	public float getctr5()
	{
		return ctr5;
	}
	
	/**
	* get ctr6
	* @return ctr6
	*/
	public float getctr6()
	{
		return ctr6;
	}
	
	/**
	* get ctrz1
	* @return ctrz1
	*/
	public float getctrz1()
	{
		return ctrz1;
	}
	
	/**
	* get ctrz2
	* @return ctrz2
	*/
	public float getctrz2()
	{
		return ctrz2;
	}
	
	/**
	* get ctrz3
	* @return ctrz3
	*/
	public float getctrz3()
	{
		return ctrz3;
	}
	
	/**
	* get ctrz4
	* @return ctrz4
	*/
	public float getctrz4()
	{
		return ctrz4;
	}
	
	/**
	* get ctrz5
	* @return ctrz5
	*/
	public float getctrz5()
	{
		return ctrz5;
	}
	
	/**
	* get ctrz6
	* @return ctrz6
	*/
	public float getctrz6()
	{
		return ctrz6;
	}
	
	/**
	* get controlpoints for the racket
	* @return M[]
	*/
	public float[] getM()
	{
		return M;   		
	}
}