import javax.swing.UIManager;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.lang.*;
import java.util.*;

/**
* Tennis - Frame
* Starts the application
* @author Marte Horne
* @version  1 - 2002...
*/
public class Tennis extends JFrame implements ActionListener
{
	//Panel
	JPanel contentPane;
	// window events
	WindowHandler wHandler;
	// mouse hit
	MouseHandler mHandler;

	// rotation angles, set in mousedragged
	private float rotx=0.0f;
   private float rotz=0.0f;
	private float lastx=0.0f;
	private float lastz=0.0f;
	private Dimension d;
	//boolean m_is_moving=false;
	boolean menuEn, menuTo, menuTre, menuFire;
	
	private Thread t_game;

  	// gl4java canvas_c
  	private MyGLCanvas canvas_c;
  	private JButton start = null;
  	//Stuff to the menu
  	private MenuBar bar;
   private Menu fil, about;
   private MenuItem resetM, nullM, enM, toM, treM, fireM, exitM;
   private MenuItem aboutM;

  	/**
   * Constructor
	*/
  	public Tennis()
  	{
   	contentPane = (JPanel) this.getContentPane();
    	contentPane.setLayout(new BorderLayout());
    	this.setSize(new Dimension(600, 400));
    	this.setTitle(" Banen ");

	    // gl4 java stuff
	    d = getSize();
	    
	    //Centering the frame on the screen
	    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
       Dimension frameSize = this.getSize();
       if (frameSize.height > screenSize.height)
          frameSize.height = screenSize.height;
       if (frameSize.width > screenSize.width)
          frameSize.width = screenSize.width;
          this.setLocation ((screenSize.width - frameSize.width)/2, (screenSize.height - frameSize.height)/4);
	    
	    canvas_c = new MyGLCanvas(this,d.width, d.height);
	    contentPane.add("Center", canvas_c);
	    
	    //Makes the menu
	    makeMenu();

	    start = new JButton( "Start" );
    	 start.addActionListener(this);
    	 contentPane.add("South", start);

	    //add mouse listener to the canvas_c
	    mHandler = new MouseHandler();
	    canvas_c.addMouseListener( mHandler );
	    canvas_c.addMouseMotionListener( mHandler );

	    // add windowlistener to frame
	    wHandler=new WindowHandler();
	    this.addWindowListener(wHandler);

	    pack();
	    show();
	}
	
	/**
   * makeMenu()
	*/
	public void makeMenu()
	{
		//Setter opp menybaren med items
      bar = new MenuBar();
      this.setMenuBar (bar);
      
      fil = new Menu ("File");
      bar.add (fil);
      
      MenuItem nullM = new MenuItem ("Null");
      fil.add(nullM);
      nullM.addActionListener(this);      
      
      MenuItem enM = new MenuItem ("En");
      fil.add(enM);
      enM.addActionListener(this);      
      
      MenuItem toM = new MenuItem ("To");
      fil.add(toM);
      toM.addActionListener(this);
      
      MenuItem treM = new MenuItem ("Tre");
      fil.add(treM);
      treM.addActionListener(this);
      
      MenuItem fireM = new MenuItem ("Fire");
      fil.add(fireM);
      fireM.addActionListener(this);
      
      fil.addSeparator();
      
      MenuItem exitM = new MenuItem ("Exit");
      fil.add(exitM);
      exitM.addActionListener(this);
      
      about = new Menu ("About");
      bar.add (about);
      
      MenuItem aboutM = new MenuItem ("About");
      about.add(aboutM);
      about.addActionListener(this);
	}

  	/**
   * actionPerformed
   * @param e ActionEvent e
	*/
  	public void actionPerformed( ActionEvent e )
   {
   	String cmd = e.getActionCommand();
   	
   	//Starts the game
   	if (cmd == "Start")
   	{
   	    start.setEnabled(false);
   		 t_game = new Thread(canvas_c);
   		 t_game.start();
   	}
   	//No lanes
   	else if (cmd == "Null")
   	{
   		menuEn = false;
   		menuTo = false;
   		menuTre = false;
   		menuFire = false;
   		canvas_c.display();
   	}
   	//The first lane
   	else if (cmd == "En")
   	{
   		menuEn = true;
   		menuTo = false;
   		menuTre = false;
   		menuFire = false;
   		canvas_c.display();
   	}
   	//The second lane
   	else if (cmd == "To")
   	{
   		menuEn = false;
   		menuTo = true;
   		menuTre = false;
   		menuFire = false;
   		canvas_c.display();
   	}
   	//The third lane
   	else if (cmd == "Tre")
   	{
   		menuEn = false;
   		menuTo = false;
   		menuTre = true;
   		menuFire = false;
   		canvas_c.display();
   	}
   	//The fourth lane
   	else if (cmd == "Fire")
   	{
   		menuEn = false;
   		menuTo = false;
   		menuTre = false;
   		menuFire = true;
   		canvas_c.display();
   	}
   	//The about box
   	else if (cmd == "About")
   	{
			JOptionPane.showMessageDialog(null,"Grafisk Databehandling \n Marte Horne \n Vren 2002");      		
   	}
   	//Exit
   	else if (cmd == "Exit")
   	{
          System.exit(0);
   	}
	}

	// --------------------------------------------
	// inner class for window events, interface WindowListener
  	public class WindowHandler implements WindowListener
  	{
  		public void windowOpened(WindowEvent parm1) {}
  		public void windowClosing(WindowEvent parm1)
  		{
       	System.exit( 0 );
  		}
  		public void windowClosed(WindowEvent parm1) {}
  		public void windowIconified(WindowEvent parm1) {}
  		public void windowDeiconified(WindowEvent parm1) {}
  		public void windowActivated(WindowEvent parm1) {}
  		public void windowDeactivated(WindowEvent parm1) {}
  	}


	//----------------------------------------------
	// innner class to handle mouse moves
  	public class MouseHandler implements MouseListener, MouseMotionListener
  	{
    	public void mouseEntered(MouseEvent e) {}
    	public void mouseExited(MouseEvent e) {}
    	public void mouseMoved(MouseEvent e) {}
    	public void mouseClicked(MouseEvent e) {}
    	public void mouseReleased(MouseEvent e){}

    	/**
   	* mousePressed
   	* @param e MouseEvent e
		*/
    	public void mousePressed(MouseEvent e)
    	{
         lastx = e.getX();
         lastz = e.getY();
    	}

    	/**
   	* mouseDragged
   	* @param e MouseEvent e
		*/
    	public void mouseDragged(MouseEvent e)
    	{
      	int x = e.getX();
      	int y = e.getY();
      	Dimension dim = e.getComponent().getSize();
      	int width = dim.width;
      	int height = dim.height;

      	rotz += (90.0f*((float)(x-lastx)/(float)(width)));
      	rotx += (90.0f*((float)(y-lastz)/(float)(height)));

      	lastx = x;
      	lastz = y;

      	// repaint with moving flag set
      	canvas_c.repaint();
    	}
   }

   /**
   * get the rotation of the x-axis
   * @return rotx
	*/
   public float getrotx()
   {
   	return rotx;
   }

   /**
   * get the rotation of the z-axis
   * @return rotz
	*/
   public float getrotz()
   {
   	return rotz;
   }

   /**
   * get the last value of the x-axis
   * @return lastx
	*/
   public float getlastx()
   {
   	return lastx;
   }

   /**
   * get the last value of the z-axis
   * @return lastz
	*/
   public float getlastz()
   {
   	return lastz;
   }
   
   /**
   * set the rotation of the x-axis
   * @param f
	*/
   public void setrotx(float f)
   {
   	rotx = f;
   }

   /**
   * set the rotation of the y-axis
   * @param f
	*/
   public void setroty(float f)
   {
   	rotz = f;
   }
   
   /**
   * get the first menu-item
   * @return menEn
	*/
   public boolean getmenuEn()
   {
   	return menuEn;
   }
   
   /**
   * get the second menu-item
   * @return menTo
	*/
   public boolean getmenuTo()
   {
   	return menuTo;
   }
   
   /**
   * get the third menu-item
   * @return menTre
	*/
   public boolean getmenuTre()
   {
   	return menuTre;
   }
   
   /**
   * get the fourth menu-item
   * @return menFire
	*/
   public boolean getmenuFire()
   {
   	return menuFire;
   }
}